

# OPEN NEW PROJECT
closeProject()
newProject( "CONCRETE_BEAM_B-E-L_MASTER", 10 )
setModelAnalysisAspects( [ "STRUCT" ] )
setModelDimension( "2D" )
#setDefaultMeshOrder( "LINEAR" )     
setDefaultMeshOrder( "QUADRATIC" )	 
setDefaultMesherType( "HEXQUAD" )
setUnit( "LENGTH", "MM" )
setUnit( "FORCE", "N" )


# INITIALIZE SHAPE LIST AND SHAPE NUMBERING
SHAPELIST = []
SHAPENUMBER = 1
SELTOL = 0.01	

from TOP_FUNC import A_TOP as A_TOP
import os
from math import pi


# SET PARAMETERS
DIST = 500
VERTDIST = 187.5
SUPPORT_LEFT = 120
HORDIST = 130
SUPPORT_MID = 160
SUPPORT_RIGHT = 120
UTSPARING_LEFT = 250
UTSPARING_RIGHT = 250
OVERHANG = 100
LOADPLATE_LEFT = 200
LOADPLATE_RIGHT = 200
PLATETHICKNESS = 45

HEIGHT = 625
WIDTH = 120

TOTALLOAD = -699552.1
POINTLOAD = TOTALLOAD/2 
LOADDISTRIBUTED = TOTALLOAD/LOADPLATE_LEFT

PRESCRIBEDDISPLACEMENT = -4.5  

#LONGITUDINAL LONG REINFORCEMENT (TOP AND BOTTOM)
DIAMLONGTOP = 12
DIAMLONGBOTTOM = 12                                  	
ASLTOP = (pi/4*DIAMLONGTOP**2)*4 
ASLBOTTOM = (pi/4*DIAMLONGBOTTOM**2)*4   


#LONGITUDINAL SHORT REINFORCEMENT (TOP)                  
DIAMSHORT = 10
ASSHORT = (pi/4*DIAMSHORT**2)*2


#Web Reinforcement
DIAMVERTICAL = 8										
DIAMHORIZONTAL = 8
ASHORIZONTAL = (pi/4*DIAMHORIZONTAL**2)*2					
ASVERTICAL = (pi/4*DIAMVERTICAL**2)*2
COVER = 25
SPACING = 200            	

ELEMENTSIZE = HEIGHT/12   							


 
YOUNGSMOD = 30597			# Eci (youngs modulus after 28 days) = Ec0*(fcm/fcm0)^1/3 (Ec0=22000 N/mm2 , fcm0 = 10 MPa)
POISSONRATIO = 0.15
FCT = 2.1286  #fctm			# Tensile strength (mean)(0.3*fck^2/3 = 0.3*(18,9^2/3)) 
FC = 26.9   #fcm           	# Compressive strength (here sylinder) according to technical paper 
GF = 0.132					# Fracture Energy (73*fcm^0.18)/1000 = 
GC = 33    				    # Compressive fracture energy (250*GF) 
BETA = 0.1					 

FY12= 510
FY10= 590
FY08= 400
FY_Steel_Plate = 355
AS_TOT = (ASLTOP+ASLBOTTOM+ASSHORT+ASHORIZONTAL+ASVERTICAL)
FY_average = (FY12*(ASLTOP+ASLBOTTOM)+FY10*ASSHORT+FY08*(ASHORIZONTAL+ASVERTICAL))/AS_TOT

ES12= 201000.0
ES10= 194000.0
ES08= 195000.0
ES_average = (ES12*ASLTOP+ES12*ASLBOTTOM+ES10*ASSHORT+ES08*ASHORIZONTAL+ES08*ASVERTICAL)/AS_TOT
EHTOT = 4000       
EPSMAX = 0.1        



ES_STEEL = 210000
POISSON_STEEL = 0.3

# ESTABLISH LISTS WITH COORDINATES
XCOORD = [0]
XCOORD.append(XCOORD[0]+OVERHANG)
XCOORD.append(XCOORD[1]+SUPPORT_LEFT/2)
XCOORD.append(XCOORD[2]+SUPPORT_LEFT/2)
XCOORD.append(XCOORD[3]+HORDIST)
XCOORD.append(XCOORD[4]+UTSPARING_LEFT)
XCOORD.append(XCOORD[5]+SUPPORT_LEFT)
XCOORD.append(XCOORD[6]+LOADPLATE_LEFT/2)
XCOORD.append(XCOORD[7]+LOADPLATE_LEFT/2)
XCOORD.append(XCOORD[8]+DIST)
XCOORD.append(XCOORD[9]+SUPPORT_MID/2)
XCOORD.append(XCOORD[10]+SUPPORT_MID/2)
XCOORD.append(XCOORD[11]+DIST)
XCOORD.append(XCOORD[12]+LOADPLATE_RIGHT/2)
XCOORD.append(XCOORD[13]+LOADPLATE_RIGHT/2)
XCOORD.append(XCOORD[14]+SUPPORT_LEFT)
XCOORD.append(XCOORD[15]+UTSPARING_RIGHT)
XCOORD.append(XCOORD[16]+HORDIST)
XCOORD.append(XCOORD[17]+SUPPORT_RIGHT/2)
XCOORD.append(XCOORD[18]+SUPPORT_RIGHT/2)
XCOORD.append(XCOORD[19]+OVERHANG)


YCOORD = [0]
YCOORD.append(YCOORD[0]+VERTDIST)
YCOORD.append(YCOORD[1]+UTSPARING_LEFT)
YCOORD.append(YCOORD[2]+VERTDIST)


#ESTABLISH LIST WITH COORDINATES FOR SUPPORT PLATE 
XSUPPORTCOORD = [0]
XSUPPORTCOORD.append(XSUPPORTCOORD[0]+OVERHANG)
XSUPPORTCOORD.append(XSUPPORTCOORD[1]+SUPPORT_LEFT/2)
XSUPPORTCOORD.append(XSUPPORTCOORD[2]+SUPPORT_LEFT/2)
XSUPPORTCOORD.append(XSUPPORTCOORD[3]+HORDIST)
XSUPPORTCOORD.append(XSUPPORTCOORD[4]+UTSPARING_LEFT)
XSUPPORTCOORD.append(XSUPPORTCOORD[5]+SUPPORT_LEFT)
XSUPPORTCOORD.append(XSUPPORTCOORD[6]+LOADPLATE_LEFT/2)
XSUPPORTCOORD.append(XSUPPORTCOORD[7]+LOADPLATE_LEFT/2)
XSUPPORTCOORD.append(XSUPPORTCOORD[8]+DIST)
XSUPPORTCOORD.append(XSUPPORTCOORD[9]+SUPPORT_MID/2)
XSUPPORTCOORD.append(XSUPPORTCOORD[10]+SUPPORT_MID/2)
XSUPPORTCOORD.append(XSUPPORTCOORD[11]+DIST)
XSUPPORTCOORD.append(XSUPPORTCOORD[12]+LOADPLATE_RIGHT/2)
XSUPPORTCOORD.append(XSUPPORTCOORD[13]+LOADPLATE_RIGHT/2)
XSUPPORTCOORD.append(XSUPPORTCOORD[14]+SUPPORT_LEFT)
XSUPPORTCOORD.append(XSUPPORTCOORD[15]+UTSPARING_RIGHT)
XSUPPORTCOORD.append(XSUPPORTCOORD[16]+HORDIST)
XSUPPORTCOORD.append(XSUPPORTCOORD[17]+SUPPORT_RIGHT/2)
XSUPPORTCOORD.append(XSUPPORTCOORD[18]+SUPPORT_RIGHT/2)
XSUPPORTCOORD.append(XSUPPORTCOORD[19]+OVERHANG)

YSUPPORTCOORD = [0]
YSUPPORTCOORD.append(YSUPPORTCOORD[0]-PLATETHICKNESS) 


#ESTABLISH LIST WITH COORDINATES FOR LOAD PLATE 
XLOADCOORD = [0]
XLOADCOORD.append(XLOADCOORD[0]+OVERHANG)
XLOADCOORD.append(XLOADCOORD[1]+SUPPORT_LEFT/2)
XLOADCOORD.append(XLOADCOORD[2]+SUPPORT_LEFT/2)
XLOADCOORD.append(XLOADCOORD[3]+HORDIST)
XLOADCOORD.append(XLOADCOORD[4]+UTSPARING_LEFT)
XLOADCOORD.append(XLOADCOORD[5]+SUPPORT_LEFT)
XLOADCOORD.append(XLOADCOORD[6]+LOADPLATE_LEFT/2)
XLOADCOORD.append(XLOADCOORD[7]+LOADPLATE_LEFT/2)
XLOADCOORD.append(XLOADCOORD[8]+DIST)
XLOADCOORD.append(XLOADCOORD[9]+SUPPORT_MID/2)
XLOADCOORD.append(XLOADCOORD[10]+SUPPORT_MID/2)
XLOADCOORD.append(XLOADCOORD[11]+DIST)
XLOADCOORD.append(XLOADCOORD[12]+LOADPLATE_RIGHT/2)
XLOADCOORD.append(XLOADCOORD[13]+LOADPLATE_RIGHT/2)
XLOADCOORD.append(XLOADCOORD[14]+SUPPORT_LEFT)
XLOADCOORD.append(XLOADCOORD[15]+UTSPARING_RIGHT)
XLOADCOORD.append(XLOADCOORD[16]+HORDIST)
XLOADCOORD.append(XLOADCOORD[17]+SUPPORT_RIGHT/2)
XLOADCOORD.append(XLOADCOORD[18]+SUPPORT_RIGHT/2)
XLOADCOORD.append(XLOADCOORD[19]+OVERHANG)

YLOADCOORD = [0]
YLOADCOORD.append(YLOADCOORD[0]+VERTDIST)
YLOADCOORD.append(YLOADCOORD[1]+UTSPARING_LEFT)
YLOADCOORD.append(YLOADCOORD[2]+VERTDIST)
YLOADCOORD.append(YLOADCOORD[3]+PLATETHICKNESS) 


# CREATE GEOMETRY
SHAPENUMBER = 1
SHAPELIST = []
SHAPENUMBER,SHAPELIST = A_TOP(1,1,20,1,SHAPENUMBER,SHAPELIST,XCOORD,YCOORD,createSheet)
SHAPENUMBER,SHAPELIST = A_TOP(1,2,4,1,SHAPENUMBER,SHAPELIST,XCOORD,YCOORD,createSheet)
SHAPENUMBER,SHAPELIST = A_TOP(6,2,10,1,SHAPENUMBER,SHAPELIST,XCOORD,YCOORD,createSheet)
SHAPENUMBER,SHAPELIST = A_TOP(17,2,4,1,SHAPENUMBER,SHAPELIST,XCOORD,YCOORD,createSheet)
SHAPENUMBER,SHAPELIST = A_TOP(1,3,20,1,SHAPENUMBER,SHAPELIST,XCOORD,YCOORD,createSheet)
SHAPENUMBER,SHAPELIST = A_TOP(2,1,2,1,SHAPENUMBER,SHAPELIST,XSUPPORTCOORD,YSUPPORTCOORD,createSheet)
SHAPENUMBER,SHAPELIST = A_TOP(10,1,2,1,SHAPENUMBER,SHAPELIST,XSUPPORTCOORD,YSUPPORTCOORD,createSheet)
SHAPENUMBER,SHAPELIST = A_TOP(18,1,2,1,SHAPENUMBER,SHAPELIST,XSUPPORTCOORD,YSUPPORTCOORD,createSheet)
SHAPENUMBER,SHAPELIST = A_TOP(7,4,2,1,SHAPENUMBER,SHAPELIST,XLOADCOORD,YLOADCOORD,createSheet)
SHAPENUMBER,SHAPELIST = A_TOP(13,4,2,1,SHAPENUMBER,SHAPELIST,XLOADCOORD,YLOADCOORD,createSheet)
fitAll()


# LONGITUDINAL Ø12 REINFORCEMENT TOP & BOTTOM
P1 = [XCOORD[0],YCOORD[3]-COVER,0]
P2 = [XCOORD[20],YCOORD[3]-COVER,0]
createLine( 'LONGREINFTOP',  P1, P2 )
P1 = [XCOORD[0],COVER,0]
P2 = [XCOORD[20],COVER,0]
createLine( 'LONGREINFBOTTOM',  P1, P2 )

LONGREINFTOP = ["LONGREINFTOP"]
LONGREINFBOTTOM = ["LONGREINFBOTTOM"]


# LONGITUDINAL SHORT Ø10 REINFORCEMENT TOP

P1 = [XCOORD[0]+OVERHANG+SUPPORT_LEFT/2+SUPPORT_LEFT/2+HORDIST+UTSPARING_LEFT,YCOORD[3]-COVER*2,0]
P2 = [XCOORD[20]-OVERHANG-SUPPORT_RIGHT/2-SUPPORT_RIGHT/2-HORDIST-UTSPARING_RIGHT,YCOORD[3]-COVER*2,0]
createLine( 'SHORTREINFTOP',  P1, P2 )

SHORTREINFTOP = ["SHORTREINFTOP"]


# HORISONTAL Ø8 WEBREINFORCEMENT 
S1 = [XCOORD[0],YCOORD[2]-COVER,0]
S2 = [XCOORD[4],YCOORD[2]-COVER,0]
createLine( 'HORWEBREINF1',  S1, S2 )
S1 = [XCOORD[0],YCOORD[1]+COVER,0]
S2 = [XCOORD[4],YCOORD[1]+COVER,0]
createLine( 'HORWEBREINF2',  S1, S2 )
S1 = [XCOORD[5],YCOORD[2]-COVER,0]
S2 = [XCOORD[15],YCOORD[2]-COVER,0]
createLine( 'HORWEBREINF3',  S1, S2 )
S1 = [XCOORD[5],YCOORD[1]+COVER,0]
S2 = [XCOORD[15],YCOORD[1]+COVER,0]
createLine( 'HORWEBREINF4',  S1, S2 )
S1 = [XCOORD[16],YCOORD[2]-COVER,0]
S2 = [XCOORD[20],YCOORD[2]-COVER,0]
createLine( 'HORWEBREINF5',  S1, S2 )
S1 = [XCOORD[16],YCOORD[1]+COVER,0]
S2 = [XCOORD[20],YCOORD[1]+COVER,0]
createLine( 'HORWEBREINF6',  S1, S2 )


HORWEBREINF = ["HORWEBREINF1","HORWEBREINF2","HORWEBREINF3","HORWEBREINF4","HORWEBREINF5","HORWEBREINF6"]


# VERTICAL Ø8 WEBREINFORCEMENT 
VERT_WEB = [OVERHANG]   
AS_WEB_VERT = []
for i in range(1,15):
   VERT_WEB.append(VERT_WEB[i-1]+SPACING)

SNUM = 1
for i in range(0,len(VERT_WEB)):


	if VERT_WEB[i] == OVERHANG + 2*SPACING or VERT_WEB[i] == OVERHANG + 12*SPACING:   
		P1 = [VERT_WEB[i],YCOORD[0]+COVER,0]
		P2 = [VERT_WEB[i],YCOORD[1]-COVER,0]
		P3 = [VERT_WEB[i],YCOORD[2]+COVER,0]
		P4 = [VERT_WEB[i],YCOORD[3]-COVER,0]
		LINENAME = 'VERT_WEB{}'.format(SNUM)
		LINENAME2 = 'VERT_WEB{}'.format(SNUM+1)
		createLine( LINENAME,  P1, P2 )
		createLine( LINENAME2,  P3, P4 )
		AS_WEB_VERT.append(LINENAME)
		AS_WEB_VERT.append(LINENAME2)
		SNUM = SNUM + 2
   
	else:
		P1 = [VERT_WEB[i],YCOORD[0]+COVER,0]
		P2 = [VERT_WEB[i],YCOORD[3]-COVER,0]
		LINENAME = 'VERT_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_WEB_VERT.append(LINENAME)
		SNUM = SNUM + 1



   

# DEFINE PROPERTIES FOR THE CONCRETE GEOMETRY AND MATERIAL
# TOTAL STRAIN FIXED CRACKING
addMaterial( "Concrete", "CONCR", "TSCR", [] )
setParameter( MATERIAL, "Concrete", "LINEAR/ELASTI/YOUNG", YOUNGSMOD )
setParameter( MATERIAL, "Concrete", "LINEAR/ELASTI/POISON", POISSONRATIO )

setParameter( MATERIAL, "Concrete", "MODTYP/TOTCRK", "FIXED" )   

setParameter( MATERIAL, "Concrete", "COMPRS/COMCRV", "PARABO" )    
setParameter( MATERIAL, "Concrete", "COMPRS/COMSTR", FC )
setParameter( MATERIAL, "Concrete", "COMPRS/GC", GC )
setParameter( MATERIAL, "Concrete", "COMPRS/CONFIN/CNFCRV", "VECCHI" )
setParameter( MATERIAL, "Concrete", "COMPRS/REDUCT/REDCRV", "VC1993" )

setParameter( MATERIAL, "Concrete", "TENSIL/TENCRV", "MC2010" )   
setParameter( "MATERIAL", "Concrete", "TENSIL/CBSPEC", "ROTS" )
setParameter( MATERIAL, "Concrete", "TENSIL/TENSTR", FCT )
setParameter( MATERIAL, "Concrete", "TENSIL/GF1", GF ) 
setParameter( MATERIAL, "Concrete", "TENSIL/POISRE/POIRED", "DAMAGE" )  

setParameter( MATERIAL, "Concrete", "SHEAR/SHRCRV", "DAMAGE" )
setParameter( MATERIAL, "Concrete", "SHEAR/BETA", BETA )    

CONMATNAME = "Concrete"
addGeometry( CONMATNAME, "SHEET", "MEMBRA", [] )
setParameter( GEOMET, CONMATNAME, "THICK", WIDTH )

assignMaterial( CONMATNAME, "SHAPE", SHAPELIST[0:58] )
assignGeometry( CONMATNAME, "SHAPE", SHAPELIST[0:58] )


# DEFINE PROPERTIES FOR THE REINFORCEMENT GEOMETRY AND MATERIAL
setReinforcementAspects( LONGREINFTOP )
setReinforcementAspects( LONGREINFBOTTOM )
setReinforcementAspects( SHORTREINFTOP )
setReinforcementAspects( HORWEBREINF )
setReinforcementAspects( AS_WEB_VERT )
RMATNAME_LONG_TOP = "Steel reinforcement top"
RMATNAME_LONG_BOTTOM = "Steel reinforcement bottom"
RMATNAME_SHORT = "Steel reinforcement top2"
SMATNAME_HORWEB = "HORWEB"
SMATNAME_VERTWEB = "VERTWEB"


# DEFINE PROPERTIES FOR THE STEEL GEOMETRY AND MATERIAL
# TOTAL STRAIN FIXED CRACKING
addMaterial( "Steelplate", "MCSTEL", "TRESCA", [] )   
setParameter( MATERIAL, "Steelplate", "TREPLA/YIELD", "VMISES" )
setParameter( MATERIAL, "Steelplate", "LINEAR/ELASTI/YOUNG", ES_STEEL )
setParameter( MATERIAL, "Steelplate", "LINEAR/ELASTI/POISON", POISSON_STEEL ) 
setParameter( MATERIAL, "Steelplate", "TREPLA/YLDSTR", FY_Steel_Plate ) 

STEELMATNAME = "Steelplate"
addGeometry( STEELMATNAME, "SHEET", "MEMBRA", [] )
setParameter( GEOMET, STEELMATNAME, "THICK", WIDTH )

assignMaterial( STEELMATNAME, "SHAPE", SHAPELIST[58:68] )
assignGeometry( STEELMATNAME, "SHAPE", SHAPELIST[58:68] )


#SMAX AND EPSPLMAX ARE THE PARAMETERS FOR THE NONLINEAR HARDENING RELATION BETWEEN YIELD STRESS AND PLASTIC STRAIN   

SMAXTOPLONG = FY12 + EHTOT*(EPSMAX - FY12/ES12)
EPSPLMAXTOPLONG = EPSMAX*(1-EHTOT/ES12) + FY12/ES12*(EHTOT/ES12 - 1)
SMAXBOTTOMLONG = FY12 + EHTOT*(EPSMAX - FY12/ES12)
EPSPLMAXBOTTOMLONG = EPSMAX*(1-EHTOT/ES12) + FY12/ES12*(EHTOT/ES12 - 1)
SMAXTOPSHORT = FY10 + EHTOT*(EPSMAX - FY10/ES10)
EPSPLMAXTOPSHORT = EPSMAX*(1-EHTOT/ES10) + FY10/ES10*(EHTOT/ES10 - 1)
SMAXVERTWEB = FY08 + EHTOT*(EPSMAX - FY08/ES08)
EPSPLMAXVERTWEB = EPSMAX*(1-EHTOT/ES08) + FY08/ES08*(EHTOT/ES08 - 1)
SMAXHORWEB = FY08 + EHTOT*(EPSMAX - FY08/ES08)
EPSPLMAXHORWEB = EPSMAX*(1-EHTOT/ES08) + FY08/ES08*(EHTOT/ES08 - 1)

addMaterial( RMATNAME_LONG_TOP, "REINFO", "VMISES", [] )
setParameter( MATERIAL, RMATNAME_LONG_TOP, "LINEAR/ELASTI/YOUNG", ES12 )
setParameter( MATERIAL, RMATNAME_LONG_TOP, "PLASTI/YLDTYP", "KAPSIG" )
setParameter( MATERIAL, RMATNAME_LONG_TOP, "PLASTI/HARDI2/KAPSIG", [] )
setParameter( MATERIAL, RMATNAME_LONG_TOP, "PLASTI/HARDI2/KAPSIG", [ 0, FY12, EPSPLMAXTOPLONG, SMAXTOPLONG ] )

addMaterial( RMATNAME_LONG_BOTTOM, "REINFO", "VMISES", [] )
setParameter( MATERIAL, RMATNAME_LONG_BOTTOM, "LINEAR/ELASTI/YOUNG", ES12 )
setParameter( MATERIAL, RMATNAME_LONG_BOTTOM, "PLASTI/YLDTYP", "KAPSIG" )
setParameter( MATERIAL, RMATNAME_LONG_BOTTOM, "PLASTI/HARDI2/KAPSIG", [] )
setParameter( MATERIAL, RMATNAME_LONG_BOTTOM, "PLASTI/HARDI2/KAPSIG", [ 0, FY12, EPSPLMAXBOTTOMLONG, SMAXBOTTOMLONG ] )

addMaterial( RMATNAME_SHORT, "REINFO", "VMISES", [] )
setParameter( MATERIAL, RMATNAME_SHORT, "LINEAR/ELASTI/YOUNG", ES10 )
setParameter( MATERIAL, RMATNAME_SHORT, "PLASTI/YLDTYP", "KAPSIG" )
setParameter( MATERIAL, RMATNAME_SHORT, "PLASTI/HARDI2/KAPSIG", [] )
setParameter( MATERIAL, RMATNAME_SHORT, "PLASTI/HARDI2/KAPSIG", [ 0, FY10, EPSPLMAXTOPSHORT, SMAXTOPSHORT ] )

addMaterial( SMATNAME_HORWEB, "REINFO", "VMISES", [] )
setParameter( MATERIAL, SMATNAME_HORWEB, "LINEAR/ELASTI/YOUNG", ES08 )
setParameter( MATERIAL, SMATNAME_HORWEB, "PLASTI/YLDTYP", "KAPSIG" )
setParameter( MATERIAL, SMATNAME_HORWEB, "PLASTI/HARDI2/KAPSIG", [] )
setParameter( MATERIAL, SMATNAME_HORWEB, "PLASTI/HARDI2/KAPSIG", [ 0, FY08, EPSPLMAXHORWEB, SMAXHORWEB ] )

addMaterial( SMATNAME_VERTWEB, "REINFO", "VMISES", [] )
setParameter( MATERIAL, SMATNAME_VERTWEB, "LINEAR/ELASTI/YOUNG", ES08 )
setParameter( MATERIAL, SMATNAME_VERTWEB, "PLASTI/YLDTYP", "KAPSIG" )
setParameter( MATERIAL, SMATNAME_VERTWEB, "PLASTI/HARDI2/KAPSIG", [] )
setParameter( MATERIAL, SMATNAME_VERTWEB, "PLASTI/HARDI2/KAPSIG", [ 0, FY08, EPSPLMAXVERTWEB, SMAXVERTWEB ] )

addGeometry( RMATNAME_LONG_TOP, "RELINE", "REBAR", [] )
setParameter( GEOMET, RMATNAME_LONG_TOP, "CROSSE", ASLTOP )

addGeometry( RMATNAME_LONG_BOTTOM, "RELINE", "REBAR", [] )
setParameter( GEOMET, RMATNAME_LONG_BOTTOM, "CROSSE", ASLBOTTOM )

addGeometry( RMATNAME_SHORT, "RELINE", "REBAR", [] )
setParameter( GEOMET, RMATNAME_SHORT, "CROSSE", ASSHORT )

addGeometry( SMATNAME_HORWEB, "RELINE", "REBAR", [] )
setParameter( GEOMET, SMATNAME_HORWEB, "CROSSE", ASHORIZONTAL )

addGeometry( SMATNAME_VERTWEB, "RELINE", "REBAR", [] )
setParameter( GEOMET, SMATNAME_VERTWEB, "CROSSE", ASVERTICAL )

assignMaterial( RMATNAME_LONG_TOP, "SHAPE", LONGREINFTOP )
assignGeometry( RMATNAME_LONG_TOP, "SHAPE", LONGREINFTOP )

assignMaterial( RMATNAME_LONG_BOTTOM, "SHAPE", LONGREINFBOTTOM )
assignGeometry( RMATNAME_LONG_BOTTOM, "SHAPE", LONGREINFBOTTOM )

assignMaterial( RMATNAME_SHORT, "SHAPE", SHORTREINFTOP )
assignGeometry( RMATNAME_SHORT, "SHAPE", SHORTREINFTOP )

assignMaterial( SMATNAME_HORWEB, "SHAPE", HORWEBREINF )
assignGeometry( SMATNAME_HORWEB, "SHAPE", HORWEBREINF )

assignMaterial( SMATNAME_VERTWEB, "SHAPE", AS_WEB_VERT )
assignGeometry( SMATNAME_VERTWEB, "SHAPE", AS_WEB_VERT )


# DEFINE SUPPORTS BC
createPointSupport( "LEFTSUPPORT", "Geometry support set 1" )
setParameter( GEOMETRYSUPPORT, "LEFTSUPPORT", "AXES", [ 1, 2 ] )
setParameter( GEOMETRYSUPPORT, "LEFTSUPPORT", "TRANSL", [ 1, 1, 0 ] )
setParameter( GEOMETRYSUPPORT, "LEFTSUPPORT", "ROTATI", [ 0, 0, 0 ] )

createPointSupport( "MIDDLESUPPORT", "Geometry support set 1" )
setParameter( GEOMETRYSUPPORT, "MIDDLESUPPORT", "AXES", [ 1, 2 ] )
setParameter( GEOMETRYSUPPORT, "MIDDLESUPPORT", "TRANSL", [ 0, 1, 0 ] )
setParameter( GEOMETRYSUPPORT, "MIDDLESUPPORT", "ROTATI", [ 0, 0, 0 ] )

createPointSupport( "RIGHTSUPPORT", "Geometry support set 1" )
setParameter( GEOMETRYSUPPORT, "RIGHTSUPPORT", "AXES", [ 1, 2 ] )
setParameter( GEOMETRYSUPPORT, "RIGHTSUPPORT", "TRANSL", [ 0, 1, 0] )
setParameter( GEOMETRYSUPPORT, "RIGHTSUPPORT", "ROTATI", [ 0, 0, 0 ] )


createPointSupport( "LOADSUPPORT", "Geometry support set 1" )
setParameter( GEOMETRYSUPPORT, "LOADSUPPORT", "AXES", [ 1, 2 ] )
setParameter( GEOMETRYSUPPORT, "LOADSUPPORT", "TRANSL", [ 0, 1, 0 ] )
setParameter( GEOMETRYSUPPORT, "LOADSUPPORT", "ROTATI", [ 0, 0, 0 ] )


COORDLEFTSUPPORT = [ XSUPPORTCOORD[2] , YSUPPORTCOORD[1], 0]
COORDMIDDLESUPPORT = [ XSUPPORTCOORD[10] , YSUPPORTCOORD[1], 0]
COORDRIGHTSUPPORT = [ XSUPPORTCOORD[18] , YSUPPORTCOORD[1] , 0 ]
COORDLOADSUPPORT1 = [ XLOADCOORD[7] , YLOADCOORD[4] , 0 ]
COORDLOADSUPPORT2 = [ XLOADCOORD[13] , YLOADCOORD[4] , 0 ]

attach( GEOMETRYSUPPORT, "LEFTSUPPORT", SHAPELIST[59], [COORDLEFTSUPPORT] )
attach( GEOMETRYSUPPORT, "MIDDLESUPPORT", SHAPELIST[61], [COORDMIDDLESUPPORT] )
attach( GEOMETRYSUPPORT, "RIGHTSUPPORT", SHAPELIST[63], [COORDRIGHTSUPPORT] )
attach( GEOMETRYSUPPORT, "LOADSUPPORT", SHAPELIST[65], [COORDLOADSUPPORT1] )
attach( GEOMETRYSUPPORT, "LOADSUPPORT", SHAPELIST[67], [COORDLOADSUPPORT2] )





#2) DISPLACEMENT CONTROL (attach supports at loading plate)
addSet( GEOMETRYLOADSET, "Geometry load case 2" )
showView( "GEOM" )
createPointLoad( "Displacement control", "Geometry load case 2" )
setParameter( GEOMETRYLOAD, "Displacement control", "LODTYP", "DEFORM" )
setParameter( GEOMETRYLOAD, "Displacement control", "DEFORM/TR/VALUE", PRESCRIBEDDISPLACEMENT )
setParameter( GEOMETRYLOAD, "Displacement control", "DEFORM/TR/DIRECT", 2 )
attach( GEOMETRYLOAD, "Displacement control", "SHEET65", [[ 820, 670, 0 ]] )   
#attach( GEOMETRYLOAD, "Displacement control", "SHEET66", [[ 820, 670, 0 ]] )   
#attach( GEOMETRYLOAD, "Displacement control", "SHEET67", [[ 2180, 670, 0 ]] )  
attach( GEOMETRYLOAD, "Displacement control", "SHEET68", [[ 2180, 670, 0 ]] )  








#INTERFACE BETWEEN LOADING PLATE & BEAM
# addMaterial( "Interface Material", "INTERF", "ELASTI", [] )
# setParameter( "MATERIAL", "Interface Material", "LINEAR/IFTYP", "LIN2D" )
# setParameter( "MATERIAL", "Interface Material", "LINEAR/ELAS2/DSNY", 1e+15 )
# setParameter( "MATERIAL", "Interface Material", "LINEAR/ELAS2/DSSX", 1e+07 )
# setParameter( "MATERIAL", "Interface Material", "LINEAR/ELAS2/DSNY", 1e+15 )
# addGeometry( "Element geometry 8", "LINE", "STRINT", [] )
# rename( "GEOMET", "Element geometry 8", "Thick Interface" )
# setParameter( "GEOMET", "Thick Interface", "THICK", WIDTH )
# setParameter( "GEOMET", "Thick Interface", "LOCAXS", True )
# createLineConnection( "Loadplate_Beam" )
# setParameter( "GEOMETRYCONNECTION", "Loadplate_Beam", "CONTYP", "INTER" )
# setParameter( "GEOMETRYCONNECTION", "Loadplate_Beam", "MODE", "AUTO" )
# attachTo( "GEOMETRYCONNECTION", "Loadplate_Beam", "SOURCE", "SHEET65", [[ 770, 625, 0 ]] )
# attachTo( "GEOMETRYCONNECTION", "Loadplate_Beam", "SOURCE", "SHEET66", [[ 870, 625, 0 ]] )
# attachTo( "GEOMETRYCONNECTION", "Loadplate_Beam", "SOURCE", "SHEET67", [[ 2130, 625, 0 ]] )
# attachTo( "GEOMETRYCONNECTION", "Loadplate_Beam", "SOURCE", "SHEET68", [[ 2230, 625, 0 ]] )
# setElementClassType( "GEOMETRYCONNECTION", "Loadplate_Beam", "STRINT" )
# assignMaterial( "Interface Material", "GEOMETRYCONNECTION", "Loadplate_Beam" )
# assignGeometry( "Thick Interface", "GEOMETRYCONNECTION", "Loadplate_Beam" )


# MESHING
setElementSize( SHAPELIST, ELEMENTSIZE )
setElementClassType( SHAPELIST, "MEMBRA" )

generateMesh(shapes())

addElementData( "Element data 1" )
setParameter( DATA, "Element data 1", "INTEGR", "HIGH" )  
#setParameter( DATA, "Element data 1", "./INTEGR", [] )   
assignElementData( "Element data 1", ELEMENT, SHAPELIST )


# SET UP NON-LINEAR ANALYSIS
analysis = "Nonlinear analysis"
command  = "Structural nonlinear"
addAnalysis( analysis )
addAnalysisCommand( analysis, "NONLIN", command )

setAnalysisCommandDetail( analysis, command, "EXECUT(1)/ITERAT/METHOD/METNAM", "NEWTON" ) 
setAnalysisCommandDetail( analysis, command, "EXECUT(1)/ITERAT/METHOD/NEWTON/TYPNAM", "REGULA" )   
setAnalysisCommandDetail( analysis, command, "EXECUT(1)/ITERAT/MAXITE", 40 )           
setAnalysisCommandDetail( analysis, command, "EXECUT(1)/ITERAT/CONVER/FORCE", True )
setAnalysisCommandDetail( analysis, command, "EXECUT(1)/ITERAT/CONVER/ENERGY", True )
setAnalysisCommandDetail( analysis, command, "EXECUT(1)/ITERAT/CONVER/DISPLA", False )
setAnalysisCommandDetail( analysis, command, "EXECUT(1)/ITERAT/CONVER/FORCE/TOLCON", 0.01 )  
setAnalysisCommandDetail( analysis, command, "EXECUT(1)/ITERAT/CONVER/FORCE/NOCONV", "CONTIN" )
setAnalysisCommandDetail( analysis, command, "EXECUT(1)/ITERAT/CONVER/ENERGY/TOLCON", 0.001 )  
setAnalysisCommandDetail( analysis, command, "EXECUT(1)/ITERAT/CONVER/ENERGY/NOCONV", "CONTIN" )  
setAnalysisCommandDetail( analysis, command, "EXECUT(1)/ITERAT/CONVER/SIMULT", False )
#addAnalysisCommandDetail( analysis, command, "EXECUT(1)/SOLVE/CHOLES" )
addAnalysisCommandDetail( "Nonlinear analysis", "Structural nonlinear", "EXECUT(1)/ITERAT/LINESE" )          
setAnalysisCommandDetail( "Nonlinear analysis", "Structural nonlinear", "EXECUT(1)/ITERAT/LINESE", True )     
setAnalysisCommandDetail( "Nonlinear analysis", "Structural nonlinear", "EXECUT(1)/ITERAT/LINESE/MAXLS", 10 )    
# addAnalysisCommandDetail( "Nonlinear analysis", "Structural nonlinear", "EXECUT(1)/LOAD/STEPS/EXPLIC/ARCLEN" )     
# setAnalysisCommandDetail( "Nonlinear analysis", "Structural nonlinear", "EXECUT(1)/LOAD/STEPS/EXPLIC/ARCLEN", True ) 

setAnalysisCommandDetail( analysis, command, "EXECUT(1)/LOAD/STEPS/EXPLIC/SIZES", "0.01(100)" )
setAnalysisCommandDetail( analysis, command, "EXECUT(1)/LOGGIN/REPORT/AMOUNT", "FULL" )
setAnalysisCommandDetail( analysis, command, "EXECUT(1)/LOGGIN/REPORT/TERMIN", "STEP" )
setAnalysisCommandDetail( analysis, command, "OUTPUT(1)/SELTYP", "USER" )
addAnalysisCommandDetail( analysis, command, "OUTPUT(1)/USER" )
addAnalysisCommandDetail( analysis, command, "OUTPUT(1)/USER/DISPLA(1)/TOTAL/TRANSL/GLOBAL" )
addAnalysisCommandDetail( analysis, command, "OUTPUT(1)/USER/FORCE(1)/REACTI/TRANSL/GLOBAL" )
# addAnalysisCommandDetail( analysis, command, "OUTPUT(1)/USER/DISPLA" )
# addAnalysisCommandDetail( analysis, command, "OUTPUT(1)/USER/FORCE" )
addAnalysisCommandDetail( analysis, command, "OUTPUT(1)/USER/STRAIN(1)" )
setAnalysisCommandDetail( analysis, command, "OUTPUT(1)/USER/STRAIN(1)/TOTAL/GREEN/GLOBAL/LOCATI", "INTPNT" )  
addAnalysisCommandDetail( analysis, command, "OUTPUT(1)/USER/STRAIN(2)/TOTAL/GREEN/PRINCI" )
setAnalysisCommandDetail( analysis, command, "OUTPUT(1)/USER/STRAIN(2)/TOTAL/GREEN/PRINCI/LOCATI", "INTPNT" )
addAnalysisCommandDetail( analysis, command, "OUTPUT(1)/USER/STRAIN(3)/CRACK/GREEN" )
addAnalysisCommandDetail( analysis, command, "OUTPUT(1)/USER/STRESS" )
setAnalysisCommandDetail( analysis, command, "OUTPUT(1)/USER/STRESS(1)/TOTAL/CAUCHY/GLOBAL/LOCATI", "INTPNT" )
addAnalysisCommandDetail( analysis, command, "OUTPUT(1)/USER/STRESS(2)/TOTAL/CAUCHY/PRINCI" )
setAnalysisCommandDetail( analysis, command, "OUTPUT(1)/USER/STRESS(2)/TOTAL/CAUCHY/PRINCI/LOCATI", "INTPNT" )
addAnalysisCommandDetail( "Nonlinear analysis", "Structural nonlinear", "OUTPUT(1)/USER/STRAIN(4)/CRKWDT/GREEN/GLOBAL" )     
addAnalysisCommandDetail( "Nonlinear analysis", "Structural nonlinear", "OUTPUT(1)/USER/STRAIN(6)/CRKWDT/GREEN/PRINCI" )    
setAnalysisCommandDetail( "Nonlinear analysis", "Structural nonlinear", "OUTPUT(1)/USER/STRAIN(4)/CRKWDT/GREEN/GLOBAL/LOCATI", "INTPNT" )
addAnalysisCommandDetail( "Nonlinear analysis", "Structural nonlinear", "OUTPUT(1)/USER/STRAIN(5)/CRKSUM/GREEN/GLOBAL" )           
setAnalysisCommandDetail( "Nonlinear analysis", "Structural nonlinear", "OUTPUT(1)/USER/STRAIN(5)/CRKSUM/GREEN/GLOBAL/LOCATI", "INTPNT" )
addAnalysisCommandDetail( "Nonlinear analysis", "Structural nonlinear", "OUTPUT(1)/USER/DISPLA(2)/INCREM/TRANSL/GLOBAL" )
addAnalysisCommandDetail( "Nonlinear analysis", "Structural nonlinear", "OUTPUT(1)/USER/DISPLA(3)/INCREM/TRANSL/LOCAL" )

'''
addAnalysisCommandDetail( "Nonlinear analysis", "Structural nonlinear", "EXECUT(1)/LOAD/STEPS/EXPLIC/ARCLEN" )
setAnalysisCommandDetail( "Nonlinear analysis", "Structural nonlinear", "EXECUT(1)/LOAD/STEPS/EXPLIC/ARCLEN", True )
'''

'''

setAnalysisCommandDetail( "Nonlinear analysis", "Structural nonlinear", "EXECUT(1)/ITERAT/MAXITE", 40 )
setAnalysisCommandDetail( "Nonlinear analysis", "Structural nonlinear", "EXECUT(1)/ITERAT/CONVER/FORCE", False )
setAnalysisCommandDetail( "Nonlinear analysis", "Structural nonlinear", "EXECUT(1)/ITERAT/CONVER/DISPLA", True )
setAnalysisCommandDetail( "Nonlinear analysis", "Structural nonlinear", "EXECUT(1)/ITERAT/CONVER/DISPLA/NOCONV", "CONTIN" )
setAnalysisCommandDetail( "Nonlinear analysis", "Structural nonlinear", "EXECUT(1)/ITERAT/CONVER/ENERGY", False )

'''
'''
setAnalysisCommandDetail( "Nonlinear analysis", "Structural nonlinear", "EXECUT(1)/ITERAT/MAXITE", 40 )
addAnalysisCommandDetail( "Nonlinear analysis", "Structural nonlinear", "EXECUT(1)/ITERAT/LINESE" )
setAnalysisCommandDetail( "Nonlinear analysis", "Structural nonlinear", "EXECUT(1)/ITERAT/LINESE", True )
setAnalysisCommandDetail( "Nonlinear analysis", "Structural nonlinear", "EXECUT(1)/ITERAT/LINESE/MAXLS", 10 )
'''

# EXPORT .DAT- AND .DCF-FILE
exportModel( "CONCRETE_BEAM_B-E-L_MASTER.dat", 10 )
saveAnalysisCommands( analysis, "CONCRETE_BEAM_B-E-L_MASTER.dcf")



# RUN ANALYSIS
runSolver( analysis )
# showView( "RESULT" )
# setViewPoint( "TOP" )
# setResultPlot( "contours", "Cauchy Total Stresses/mappedintegrationpoint", "S2" )
# setViewSettingValue( "result view setting", "CONTOU/COUNT/NUMLVL", 20 )



#FIND LOAD DISPLACEMENT CURVE 
DISPCOORD = [XCOORD[3]+(XCOORD[9]-XCOORD[3])/2,YCOORD[0], 0 ]  
DISPNODE = findNearestNodes([DISPCOORD])
highlight(NODE,DISPNODE)
DISPNODELIST = [DISPNODE[0]]

FORCENODE1 = findNearestNodes([COORDLEFTSUPPORT])
FORCENODE2 = findNearestNodes([COORDMIDDLESUPPORT])
FORCENODE3 = findNearestNodes([COORDRIGHTSUPPORT])
FORCENODES = [FORCENODE1[0],FORCENODE2[0],FORCENODE3[0]]
highlight(NODE,FORCENODES)

DISPLACEMENTS = []
LASTCASE = len(resultCases(analysis,''))
for i in range(0,LASTCASE):
    DISPLACEMENTS.append(resultData([analysis,"Output",resultCases(analysis,"Output")[i],"Displacements","TDtY"],DISPNODE)[0][1])

REACTIONS = []
FORCE = 0
for i in range(0,LASTCASE):
    for j in FORCENODES:
        FORCE = FORCE + resultData([analysis,"Output",resultCases(analysis,"Output")[i],"Reaction Forces","FBY"],(j,))[0][1]
    REACTIONS.append(FORCE)
    FORCE = 0

f = open('LOADDISP_B-E-L_MASTER.TXT','w')
for i in range(0,len(REACTIONS)):
    f.write('{0:20.6f} {1:20.6f}\n'.format(DISPLACEMENTS[i],REACTIONS[i]))

f.close()


# FIND SUPPORT FORCE TOTAL LOAD CURVE
SUPPORTNODE = findNearestNodes([COORDLEFTSUPPORT])

FORCENODE1 = findNearestNodes([COORDLEFTSUPPORT])
FORCENODE2 = findNearestNodes([COORDRIGHTSUPPORT])
FORCENODE3 = findNearestNodes([COORDMIDDLESUPPORT])
FORCENODES = [FORCENODE1[0],FORCENODE2[0], FORCENODE3[0]]
highlight(NODE,FORCENODES)

SUPPORTLOAD = []
LASTCASE = len(resultCases(analysis,''))
for i in range(0,LASTCASE):
    SUPPORTLOAD.append(resultData([analysis,"Output",resultCases(analysis,"Output")[i],"Reaction Forces","FBY"],SUPPORTNODE)[0][1])

REACTIONS = []
FORCE = 0
for i in range(0,LASTCASE):
    for j in FORCENODES:
        FORCE = FORCE + resultData([analysis,"Output",resultCases(analysis,"Output")[i],"Reaction Forces","FBY"],(j,))[0][1]
    REACTIONS.append(FORCE)
    FORCE = 0

f = open('SUPPLOAD_B-E-L_MASTER.TXT','w')
for i in range(0,len(REACTIONS)):
    f.write('{0:20.6f} {1:20.6f}\n'.format(SUPPORTLOAD[i],REACTIONS[i]))

f.close()