
# OPEN NEW PROJECT
closeProject()
newProject( "CONCRETE_BEAM_RCxcb_2D_CONSTANT_SHEAR_RETENTION", 10 )
setModelAnalysisAspects( [ "STRUCT" ] )
setModelDimension( "2D" )
#setDefaultMeshOrder( "LINEAR" )     
setDefaultMeshOrder( "QUADRATIC" )	 
setDefaultMesherType( "HEXQUAD" )
setUnit( "LENGTH", "MM" )
setUnit( "FORCE", "N" )


# INITIALIZE SHAPE LIST AND SHAPE NUMBERING
SHAPELIST = []
SHAPENUMBER = 1
SELTOL = 0.01	

from TOP_FUNC import A_TOP as A_TOP
import os
from math import pi


# SET PARAMETERS
LEFTSUPPORT = 200
RIGHTSUPPORT = 200
LOADPLATE1 = 100
LOADPLATE2 = 100
LOADPLATE3 = 100
LOADPLATE4 = 100
VERTDIST = 50
VERTDIST2 = 300
PLATETHICKNESS = 40
HEIGHT = 400
WIDTH = 150
SPACING20 = 20
SPACING30 = 30
SPACING40 = 40
SPACING45 = 45
SPACING50 = 50
SPACING75 = 75
SPACING80 = 80
SPACING100 = 100
SPACING150 = 150
SPACING200 = 200
SPACING250 = 250
SPACING300 = 300
SPACING400 = 400
SPACING500 = 500
SPACING550 = 550
SPACING700 = 700
SPACING750 = 750
SPACING800 = 800
SPACING2000 = 2000
SPACING3600 = 3600
SPACING4000 = 4000
SECONDARY_BEAM_THICKNESS = 100
SPANWITH = 3800


PRESCRIBEDDISPLACEMENT = -200  


#REINFORCEMENT DIAMETER (ALL)
DIAMTWELVE = 12
DIAMTEN = 10
DIAMEIGHT = 8
DIAMSIX = 6
DIAMFOUR = 4


#REINFORCEMENT HORIZONTAL LONGITUDINAL 
ASTOP1 = (pi/4*DIAMTWELVE**2)*5
ASTOP2 = (pi/4*DIAMTWELVE**2)*5
ASBOTTOM1 = (pi/4*DIAMTWELVE**2)*5
ASBOTTOM2 = (pi/4*DIAMTWELVE**2)*5

#REINFORCEMENT VERTICAL 
ASVERT1 = (pi/4*DIAMSIX**2)*2
ASVERT2 = (pi/4*DIAMTEN**2)*2
ASVERT3 = (pi/4*DIAMTWELVE**2)*2


#REINFORCEMENT SHEAR/STIRRUPS TOP/BOTTOM
ASSTIRRUP = (pi/4*DIAMFOUR**2)*2

#REINFORCEMENT CABEL 
ASCABLE = (pi/4*DIAMTEN**2)*2



COVER = 25


#SPACING BETWEEN STIRRUPS 
SHORTSPACING = 40            	
LONGSPACING = 80            	


#ELEMENTSIZE
ELEMENTSIZE = HEIGHT/12   							


#MATERIAL PROPERTIES CONCRETE 
YOUNGSMOD = 30290			# Eci (youngs modulus after 28 days) = Ec0*(fcm/fcm0)^1/3 (Ec0=22000 N/mm2 , fcm0 = 10 MPa)
POISSONRATIO = 0.15
FCT = 2.0681  #fctm			# Tensile strength (mean)(0.3*fck^2/3 = 0.3*(18,1^2/3)) 
FC = 26.1   #fcm           	# Compressive strength (here sylinder) according to technical paper 
GF = 0.1313					# Fracture Energy (73*fcm^0.18)/1000  
GC = 32.825    				# Compressive fracture energy (250*GF) 
BETA = 0.1					


#MATERIAL PROPERTIES STEEL 
FY12= 550
FY10= 476
FY08= 480
FY06= 520
FY04= 520

FY_Steel_Plate = 355
FY_Steel_Beam = 355
ES_REINFORCEMENT= 200000.0
EHTOT = 4000       
EPSMAX = 0.1        
ES_STEEL = 210000
ES_STEELBEAM = 210000
POISSON_STEEL = 0.3
INTERFACE_NORMALSTIFFNESS = ((1000)*(ES_STEEL/ELEMENTSIZE))
INTERFACE_TANGENTIALSTIFFNESS = (INTERFACE_NORMALSTIFFNESS/10)
INTERFACE_ZEROTANGENTIALSTIFFNESS = (1*(10**(-4)))


# ESTABLISH LISTS WITH COORDINATES
XCOORD = [0]
XCOORD.append(XCOORD[0]+SPACING4000)

YCOORD = [0]
YCOORD.append(YCOORD[0]+SPACING400)



#ESTABLISH LIST WITH COORDINATES FOR SUPPORT PLATE 
XSUPPORTCOORD = [0]
XSUPPORTCOORD.append(XSUPPORTCOORD[0]+LEFTSUPPORT/2)
XSUPPORTCOORD.append(XSUPPORTCOORD[1]+LEFTSUPPORT/2)
XSUPPORTCOORD.append(XSUPPORTCOORD[2]+SPACING3600)
XSUPPORTCOORD.append(XSUPPORTCOORD[3]+RIGHTSUPPORT/2)
XSUPPORTCOORD.append(XSUPPORTCOORD[4]+RIGHTSUPPORT/2)

YSUPPORTCOORD = [0]
YSUPPORTCOORD.append(YSUPPORTCOORD[0]-PLATETHICKNESS) 


#ESTABLISH LIST WITH COORDINATES FOR LOAD PLATE 
XLOADCOORD = [0]
XLOADCOORD.append(XLOADCOORD[0]+SPACING750)
XLOADCOORD.append(XLOADCOORD[1]+LOADPLATE1)
XLOADCOORD.append(XLOADCOORD[2]+SPACING800)
XLOADCOORD.append(XLOADCOORD[3]+LOADPLATE2)
XLOADCOORD.append(XLOADCOORD[4]+SPACING500)
XLOADCOORD.append(XLOADCOORD[5]+LOADPLATE3)
XLOADCOORD.append(XLOADCOORD[6]+SPACING800)
XLOADCOORD.append(XLOADCOORD[7]+LOADPLATE4)
XLOADCOORD.append(XLOADCOORD[8]+SPACING750)

YLOADCOORD = [0]
YLOADCOORD.append(YLOADCOORD[0]+VERTDIST)
YLOADCOORD.append(YLOADCOORD[1]+VERTDIST2)
YLOADCOORD.append(YLOADCOORD[2]+VERTDIST)
YLOADCOORD.append(YLOADCOORD[3]+PLATETHICKNESS) 


#ESTABLISH LIST WITH COORDINATES FOR SECONDARY_BEAM

XBEAMCOORD = [0]
XBEAMCOORD.append(XBEAMCOORD[0]+SPACING700)
XBEAMCOORD.append(XBEAMCOORD[1]+SPACING550)
XBEAMCOORD.append(XBEAMCOORD[2]+SPACING550)
XBEAMCOORD.append(XBEAMCOORD[3]+SPACING400)
XBEAMCOORD.append(XBEAMCOORD[4]+SPACING550)
XBEAMCOORD.append(XBEAMCOORD[5]+SPACING550)
XBEAMCOORD.append(XBEAMCOORD[6]+SPACING700)

YBEAMCOORD = [0]
YBEAMCOORD.append(YLOADCOORD[0]+VERTDIST)
YBEAMCOORD.append(YLOADCOORD[1]+VERTDIST2)
YBEAMCOORD.append(YLOADCOORD[2]+VERTDIST)
YBEAMCOORD.append(YLOADCOORD[3]+PLATETHICKNESS) 
YBEAMCOORD.append(YLOADCOORD[4]+SECONDARY_BEAM_THICKNESS)


# CREATE GEOMETRY
SHAPENUMBER = 1
SHAPELIST = []
SHAPENUMBER,SHAPELIST = A_TOP(1,1,1,1,SHAPENUMBER,SHAPELIST,XCOORD,YCOORD,createSheet) 
SHAPENUMBER,SHAPELIST = A_TOP(1,0,2,1,SHAPENUMBER,SHAPELIST,XSUPPORTCOORD,YSUPPORTCOORD,createSheet) 
SHAPENUMBER,SHAPELIST = A_TOP(4,0,2,1,SHAPENUMBER,SHAPELIST,XSUPPORTCOORD,YSUPPORTCOORD,createSheet) 
SHAPENUMBER,SHAPELIST = A_TOP(2,4,1,1,SHAPENUMBER,SHAPELIST,XLOADCOORD,YLOADCOORD,createSheet) 
SHAPENUMBER,SHAPELIST = A_TOP(4,4,1,1,SHAPENUMBER,SHAPELIST,XLOADCOORD,YLOADCOORD,createSheet) 
SHAPENUMBER,SHAPELIST = A_TOP(6,4,1,1,SHAPENUMBER,SHAPELIST,XLOADCOORD,YLOADCOORD,createSheet) 
SHAPENUMBER,SHAPELIST = A_TOP(8,4,1,1,SHAPENUMBER,SHAPELIST,XLOADCOORD,YLOADCOORD,createSheet) 
SHAPENUMBER,SHAPELIST = A_TOP(2,5,2,1,SHAPENUMBER,SHAPELIST,XBEAMCOORD,YBEAMCOORD,createSheet) 
SHAPENUMBER,SHAPELIST = A_TOP(5,5,2,1,SHAPENUMBER,SHAPELIST,XBEAMCOORD,YBEAMCOORD,createSheet) 
fitAll()


#CABLE REINFORCEMENT
createCurve( "CABLE1", [[ 0, 25, 0 ],[ 590, 90, 0 ],[ 610, 70, 0 ],[ 950, 340, 0 ],[ 1250, 60, 0 ],[ 1549.38, 340, 0 ],[ 1850.54, 60, 0 ],[ 2144.09, 340, 0 ],[ 2454.66, 60, 0 ],[ 2750, 340, 0 ],[ 3052.63, 60, 0 ],[ 3400, 330, 0 ],[ 3500, 220, 0 ],[ 4000, 375, 0 ]] )
createCurve( "CABLE2", [[ 0, 375, 0 ],[ 590, 310, 0 ],[ 610, 330, 0 ],[ 950, 60, 0 ],[ 1250, 340, 0 ],[ 1550, 60, 0 ],[ 1850, 340, 0 ],[ 2144, 60, 0 ],[ 2455, 340, 0 ],[ 2750, 60, 0 ],[ 3053, 340, 0 ],[ 3400, 70, 0 ],[ 3500, 180, 0 ],[ 4000, 25, 0 ]] )

ASCABLE1 = ["CABLE1"]
ASCABLE2 = ["CABLE2"]

# LONGITUDINAL Ø12 REINFORCEMENT TOP 
P1 = [XCOORD[0]+COVER,YCOORD[1]-COVER-11,0]
P2 = [XCOORD[1]-COVER,YCOORD[1]-COVER-11,0]
createLine( 'TOPREINFORCEMENT1',  P1, P2 )
P1 = [XCOORD[0]+COVER,YCOORD[1]-COVER-39,0]
P2 = [XCOORD[1]-COVER,YCOORD[1]-COVER-39,0]
createLine( 'TOPREINFORCEMENT2',  P1, P2 )

ASTOPREINFORCEMENT1 = ["TOPREINFORCEMENT1"]
ASTOPREINFORCEMENT2 = ["TOPREINFORCEMENT2"]


# LONGITUDINAL Ø12 REINFORCEMENT BOTTOM 
P1 = [XCOORD[0]+COVER,YCOORD[0]+COVER+11,0]
P2 = [XCOORD[1]-COVER,YCOORD[0]+COVER+11,0]
createLine( 'BOTTOMREINFORCEMENT1',  P1, P2 )
P1 = [XCOORD[0]+COVER,YCOORD[0]+COVER+39,0]
P2 = [XCOORD[1]-COVER,YCOORD[0]+COVER+39,0]
createLine( 'BOTTOMREINFORCEMENT2',  P1, P2 )

ASBOTTOMREINFORCEMENT1 = ["BOTTOMREINFORCEMENT1"]
ASBOTTOMREINFORCEMENT2 = ["BOTTOMREINFORCEMENT2"]


# SMALL STIRRUPS Ø4 TOP

XSTIRR = [COVER]
ASSTIRR = []
for i in range(1,100):
   XSTIRR.append(XSTIRR[i-1]+SPACING40)


SNUM = 1
for i in range(0,len(XSTIRR)):
   P1 = [XSTIRR[i],327,0]
   P2 = [XSTIRR[i],373,0]
   LINENAME = 'STIRRUP{}'.format(SNUM)
   createLine( LINENAME,  P1, P2 )
   ASSTIRR.append(LINENAME)
   SNUM = SNUM + 1


# SMALL STIRRUPS Ø4 BOTTOM

   P1 = [XSTIRR[i],27,0]
   P2 = [XSTIRR[i],73,0]
   LINENAME = 'STIRRUP{}'.format(SNUM)
   createLine( LINENAME,  P1, P2 )
   ASSTIRR.append(LINENAME)
   SNUM = SNUM + 1

   

# LONG STIRRUPS Ø6 lEFT
XVERT1 = [COVER]
AS_VERT1 = []
for i in range(1,4):
   XVERT1.append(XVERT1[i-1]+SPACING40)

SNUM = 1
for i in range(0,len(XVERT1)):


		P1 = [XVERT1[i],YCOORD[0]+COVER,0]
		P2 = [XVERT1[i],YCOORD[1]-COVER,0]
		LINENAME = 'VERT1_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_VERT1.append(LINENAME)
		SNUM = SNUM + 1

		
# LONG STIRRUPS Ø12 lEFT		
XVERT2 = [XSUPPORTCOORD[1]+SPACING45+SPACING40]
AS_VERT2 = []
for i in range(1,3):
   XVERT2.append(XVERT2[i-1]+SPACING20)

SNUM = 1
for i in range(0,len(XVERT2)):


		P1 = [XVERT2[i],YCOORD[0]+COVER,0]
		P2 = [XVERT2[i],YCOORD[1]-COVER,0]
		LINENAME = 'VERT2_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_VERT2.append(LINENAME)
		SNUM = SNUM + 1		

				
# LONG STIRRUPS Ø12 RIGHT			
XVERT3 = [XSUPPORTCOORD[3]-SPACING50+COVER]
AS_VERT3 = []
for i in range(1,3):
   XVERT3.append(XVERT3[i-1]+SPACING20)

SNUM = 1
for i in range(0,len(XVERT3)):


		P1 = [XVERT3[i],YCOORD[0]+COVER,0]
		P2 = [XVERT3[i],YCOORD[1]-COVER,0]
		LINENAME = 'VERT3_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_VERT3.append(LINENAME)
		SNUM = SNUM + 1			

		
# LONG STIRRUPS Ø6 RIGHT		
XVERT4 = [XSUPPORTCOORD[3]+SPACING50]
AS_VERT4 = []
for i in range(1,4):
   XVERT4.append(XVERT4[i-1]+SPACING40)

SNUM = 1
for i in range(0,len(XVERT4)):


		P1 = [XVERT4[i],YCOORD[0]+COVER,0]
		P2 = [XVERT4[i],YCOORD[1]-COVER,0]
		LINENAME = 'VERT4_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_VERT4.append(LINENAME)
		SNUM = SNUM + 1		


# LONG STIRRUPS Ø10 BETWEEN OPENINGS	
		
XVERT5 = [XSUPPORTCOORD[2]+286]
AS_VERT5 = []
for i in range(1,2):
   XVERT5.append(XVERT5[i-1]+SPACING30)

SNUM = 1
for i in range(0,len(XVERT5)):


		P1 = [XVERT5[i],YCOORD[0]+COVER,0]
		P2 = [XVERT5[i],YCOORD[1]-COVER,0]
		LINENAME = 'VERT5_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_VERT5.append(LINENAME)
		SNUM = SNUM + 1		

XVERT6 = [XSUPPORTCOORD[2]+586]
AS_VERT6 = []
for i in range(1,2):
   XVERT6.append(XVERT6[i-1]+SPACING30)

SNUM = 1
for i in range(0,len(XVERT6)):


		P1 = [XVERT6[i],YCOORD[0]+COVER,0]
		P2 = [XVERT6[i],YCOORD[1]-COVER,0]
		LINENAME = 'VERT6_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_VERT6.append(LINENAME)
		SNUM = SNUM + 1		

XVERT7 = [XSUPPORTCOORD[2]+886]
AS_VERT7 = []
for i in range(1,2):
   XVERT7.append(XVERT7[i-1]+SPACING30)

SNUM = 1
for i in range(0,len(XVERT7)):


		P1 = [XVERT7[i],YCOORD[0]+COVER,0]
		P2 = [XVERT7[i],YCOORD[1]-COVER,0]
		LINENAME = 'VERT7_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_VERT7.append(LINENAME)
		SNUM = SNUM + 1		

XVERT8 = [XSUPPORTCOORD[2]+1186]
AS_VERT8 = []
for i in range(1,2):
   XVERT8.append(XVERT8[i-1]+SPACING30)

SNUM = 1
for i in range(0,len(XVERT8)):


		P1 = [XVERT8[i],YCOORD[0]+COVER,0]
		P2 = [XVERT8[i],YCOORD[1]-COVER,0]
		LINENAME = 'VERT8_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_VERT8.append(LINENAME)
		SNUM = SNUM + 1		

XVERT9 = [XSUPPORTCOORD[2]+1486]
AS_VERT9 = []
for i in range(1,2):
   XVERT9.append(XVERT9[i-1]+SPACING30)

SNUM = 1
for i in range(0,len(XVERT9)):


		P1 = [XVERT9[i],YCOORD[0]+COVER,0]
		P2 = [XVERT9[i],YCOORD[1]-COVER,0]
		LINENAME = 'VERT9_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_VERT9.append(LINENAME)
		SNUM = SNUM + 1				
		
XVERT10 = [XSUPPORTCOORD[2]+1786]
AS_VERT10 = []
for i in range(1,2):
   XVERT10.append(XVERT10[i-1]+SPACING30)

SNUM = 1
for i in range(0,len(XVERT10)):


		P1 = [XVERT10[i],YCOORD[0]+COVER,0]
		P2 = [XVERT10[i],YCOORD[1]-COVER,0]
		LINENAME = 'VERT10_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_VERT10.append(LINENAME)
		SNUM = SNUM + 1	

XVERT11 = [XSUPPORTCOORD[2]+2086]
AS_VERT11 = []
for i in range(1,2):
   XVERT11.append(XVERT11[i-1]+SPACING30)

SNUM = 1
for i in range(0,len(XVERT11)):


		P1 = [XVERT11[i],YCOORD[0]+COVER,0]
		P2 = [XVERT11[i],YCOORD[1]-COVER,0]
		LINENAME = 'VERT11_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_VERT11.append(LINENAME)
		SNUM = SNUM + 1	

XVERT12 = [XSUPPORTCOORD[2]+2386]
AS_VERT12 = []
for i in range(1,2):
   XVERT12.append(XVERT12[i-1]+SPACING30)

SNUM = 1
for i in range(0,len(XVERT12)):


		P1 = [XVERT12[i],YCOORD[0]+COVER,0]
		P2 = [XVERT12[i],YCOORD[1]-COVER,0]
		LINENAME = 'VERT12_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_VERT12.append(LINENAME)
		SNUM = SNUM + 1	

XVERT13 = [XSUPPORTCOORD[2]+2686]
AS_VERT13 = []
for i in range(1,2):
   XVERT13.append(XVERT13[i-1]+SPACING30)

SNUM = 1
for i in range(0,len(XVERT13)):


		P1 = [XVERT13[i],YCOORD[0]+COVER,0]
		P2 = [XVERT13[i],YCOORD[1]-COVER,0]
		LINENAME = 'VERT13_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_VERT13.append(LINENAME)
		SNUM = SNUM + 1	

XVERT14 = [XSUPPORTCOORD[2]+2986]
AS_VERT14 = []
for i in range(1,2):
   XVERT14.append(XVERT14[i-1]+SPACING30)

SNUM = 1
for i in range(0,len(XVERT14)):


		P1 = [XVERT14[i],YCOORD[0]+COVER,0]
		P2 = [XVERT14[i],YCOORD[1]-COVER,0]
		LINENAME = 'VERT14_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_VERT14.append(LINENAME)
		SNUM = SNUM + 1	

XVERT15 = [XSUPPORTCOORD[2]+3286]
AS_VERT15 = []
for i in range(1,2):
   XVERT15.append(XVERT15[i-1]+SPACING30)

SNUM = 1
for i in range(0,len(XVERT15)):


		P1 = [XVERT15[i],YCOORD[0]+COVER,0]
		P2 = [XVERT15[i],YCOORD[1]-COVER,0]
		LINENAME = 'VERT15_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_VERT15.append(LINENAME)
		SNUM = SNUM + 1	

	
		
# HORIZONTAL REINFORCEMENT IN WEB BETWEEN OPENINGS		
		
YHOR1 = [YCOORD[0]+SPACING100] 
AS_HOR1 = []
for j in range(1,6):
   YHOR1.append(YHOR1[j-1]+SPACING40)

SNUM = 1
for j in range(0,len(YHOR1)):


		P1 = [XSUPPORTCOORD[0]+COVER,YHOR1[j],0]
		P2 = [XSUPPORTCOORD[2]+COVER,YHOR1[j],0]
		LINENAME = 'HOR1_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_HOR1.append(LINENAME)
		SNUM = SNUM + 1


YHOR2 = [YCOORD[0]+SPACING100] 
AS_HOR2 = []
for j in range(1,6):
   YHOR2.append(YHOR2[j-1]+SPACING40)

SNUM = 1
for j in range(0,len(YHOR2)):


		P1 = [XSUPPORTCOORD[1]+SPACING45+SPACING40,YHOR2[j],0]
		P2 = [XSUPPORTCOORD[2]+COVER,YHOR2[j],0]
		LINENAME = 'HOR2_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_HOR2.append(LINENAME)
		SNUM = SNUM + 1

		
YHOR3 = [YCOORD[0]+SPACING100] 
AS_HOR3 = []
for j in range(1,6):
   YHOR3.append(YHOR3[j-1]+SPACING40)

SNUM = 1
for j in range(0,len(YHOR3)):


		P1 = [XSUPPORTCOORD[2]+275,YHOR3[j],0]
		P2 = [XSUPPORTCOORD[2]+325,YHOR3[j],0]
		LINENAME = 'HOR3_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_HOR3.append(LINENAME)
		SNUM = SNUM + 1
		
YHOR4 = [YCOORD[0]+SPACING100] 
AS_HOR4 = []
for j in range(1,6):
   YHOR4.append(YHOR4[j-1]+SPACING40)

SNUM = 1
for j in range(0,len(YHOR4)):


		P1 = [XSUPPORTCOORD[2]+575,YHOR4[j],0]
		P2 = [XSUPPORTCOORD[2]+625,YHOR4[j],0]
		LINENAME = 'HOR4_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_HOR4.append(LINENAME)
		SNUM = SNUM + 1		
		
YHOR5 = [YCOORD[0]+SPACING100] 
AS_HOR5 = []
for j in range(1,6):
   YHOR5.append(YHOR5[j-1]+SPACING40)

SNUM = 1
for j in range(0,len(YHOR5)):


		P1 = [XSUPPORTCOORD[2]+875,YHOR5[j],0]
		P2 = [XSUPPORTCOORD[2]+925,YHOR5[j],0]
		LINENAME = 'HOR5_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_HOR5.append(LINENAME)
		SNUM = SNUM + 1	

YHOR6 = [YCOORD[0]+SPACING100] 
AS_HOR6 = []
for j in range(1,6):
   YHOR6.append(YHOR6[j-1]+SPACING40)

SNUM = 1
for j in range(0,len(YHOR6)):


		P1 = [XSUPPORTCOORD[2]+1175,YHOR6[j],0]
		P2 = [XSUPPORTCOORD[2]+1225,YHOR6[j],0]
		LINENAME = 'HOR6_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_HOR6.append(LINENAME)
		SNUM = SNUM + 1	

YHOR7 = [YCOORD[0]+SPACING100] 
AS_HOR7 = []
for j in range(1,6):
   YHOR7.append(YHOR7[j-1]+SPACING40)

SNUM = 1
for j in range(0,len(YHOR7)):


		P1 = [XSUPPORTCOORD[2]+1475,YHOR7[j],0]
		P2 = [XSUPPORTCOORD[2]+1525,YHOR7[j],0]
		LINENAME = 'HOR7_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_HOR7.append(LINENAME)
		SNUM = SNUM + 1	

YHOR8 = [YCOORD[0]+SPACING100] 
AS_HOR8 = []
for j in range(1,6):
   YHOR8.append(YHOR8[j-1]+SPACING40)

SNUM = 1
for j in range(0,len(YHOR8)):


		P1 = [XSUPPORTCOORD[2]+1775,YHOR8[j],0]
		P2 = [XSUPPORTCOORD[2]+1825,YHOR8[j],0]
		LINENAME = 'HOR8_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_HOR8.append(LINENAME)
		SNUM = SNUM + 1	

YHOR9 = [YCOORD[0]+SPACING100] 
AS_HOR9 = []
for j in range(1,6):
   YHOR9.append(YHOR9[j-1]+SPACING40)

SNUM = 1
for j in range(0,len(YHOR9)):


		P1 = [XSUPPORTCOORD[2]+2075,YHOR9[j],0]
		P2 = [XSUPPORTCOORD[2]+2125,YHOR9[j],0]
		LINENAME = 'HOR9_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_HOR9.append(LINENAME)
		SNUM = SNUM + 1	

YHOR10 = [YCOORD[0]+SPACING100] 
AS_HOR10 = []
for j in range(1,6):
   YHOR10.append(YHOR10[j-1]+SPACING40)

SNUM = 1
for j in range(0,len(YHOR10)):


		P1 = [XSUPPORTCOORD[2]+2375,YHOR10[j],0]
		P2 = [XSUPPORTCOORD[2]+2425,YHOR10[j],0]
		LINENAME = 'HOR10_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_HOR10.append(LINENAME)
		SNUM = SNUM + 1	
		
YHOR11 = [YCOORD[0]+SPACING100] 
AS_HOR11 = []
for j in range(1,6):
   YHOR11.append(YHOR11[j-1]+SPACING40)

SNUM = 1
for j in range(0,len(YHOR11)):


		P1 = [XSUPPORTCOORD[2]+2675,YHOR11[j],0]
		P2 = [XSUPPORTCOORD[2]+2725,YHOR11[j],0]
		LINENAME = 'HOR11_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_HOR11.append(LINENAME)
		SNUM = SNUM + 1			
		
YHOR12 = [YCOORD[0]+SPACING100] 
AS_HOR12 = []
for j in range(1,6):
   YHOR12.append(YHOR12[j-1]+SPACING40)

SNUM = 1
for j in range(0,len(YHOR12)):


		P1 = [XSUPPORTCOORD[2]+2975,YHOR12[j],0]
		P2 = [XSUPPORTCOORD[2]+3025,YHOR12[j],0]
		LINENAME = 'HOR12_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_HOR12.append(LINENAME)
		SNUM = SNUM + 1			
		
YHOR13 = [YCOORD[0]+SPACING100] 
AS_HOR13 = []
for j in range(1,6):
   YHOR13.append(YHOR13[j-1]+SPACING40)

SNUM = 1
for j in range(0,len(YHOR13)):


		P1 = [XSUPPORTCOORD[2]+3275,YHOR13[j],0]
		P2 = [XSUPPORTCOORD[2]+3325,YHOR13[j],0]
		LINENAME = 'HOR13_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_HOR13.append(LINENAME)
		SNUM = SNUM + 1				
		
YHOR14 = [YCOORD[0]+SPACING100] 
AS_HOR14 = []
for j in range(1,6):
   YHOR14.append(YHOR14[j-1]+SPACING40)

SNUM = 1
for j in range(0,len(YHOR14)):


		P1 = [XSUPPORTCOORD[3]-COVER,YHOR14[j],0]
		P2 = [XSUPPORTCOORD[3]+SPACING20,YHOR14[j],0]
		LINENAME = 'HOR14_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_HOR14.append(LINENAME)
		SNUM = SNUM + 1	

YHOR15 = [YCOORD[0]+SPACING100] 
AS_HOR15 = []
for j in range(1,6):
   YHOR15.append(YHOR15[j-1]+SPACING40)

SNUM = 1
for j in range(0,len(YHOR15)):


		P1 = [XSUPPORTCOORD[3]-COVER,YHOR15[j],0]
		P2 = [XSUPPORTCOORD[5]-COVER,YHOR15[j],0]
		LINENAME = 'HOR15_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_HOR15.append(LINENAME)
		SNUM = SNUM + 1			
		



createSheetCircle( "Circle1", [ 350, 200, 0 ], [ 0, 0, 1 ], 100 )
subtract( "SHEET1", [ "Circle1" ], False, True )

createSheetCircle( "Circle2", [ 650, 200, 0 ], [ 0, 0, 1 ], 100 )
subtract( "SHEET1", [ "Circle2" ], False, True )

createSheetCircle( "Circle3", [ 950, 200, 0 ], [ 0, 0, 1 ], 100 )
subtract( "SHEET1", [ "Circle3" ], False, True )

createSheetCircle( "Circle4", [ 1250, 200, 0 ], [ 0, 0, 1 ], 100 )
subtract( "SHEET1", [ "Circle4" ], False, True )

createSheetCircle( "Circle5", [ 1550, 200, 0 ], [ 0, 0, 1 ], 100 )
subtract( "SHEET1", [ "Circle5" ], False, True )

createSheetCircle( "Circle6", [ 1850, 200, 0 ], [ 0, 0, 1 ], 100 )
subtract( "SHEET1", [ "Circle6" ], False, True )

createSheetCircle( "Circle7", [ 2150, 200, 0 ], [ 0, 0, 1 ], 100 )
subtract( "SHEET1", [ "Circle7" ], False, True )

createSheetCircle( "Circle8", [ 2450, 200, 0 ], [ 0, 0, 1 ], 100 )
subtract( "SHEET1", [ "Circle8" ], False, True )

createSheetCircle( "Circle9", [ 2750, 200, 0 ], [ 0, 0, 1 ], 100 )
subtract( "SHEET1", [ "Circle9" ], False, True )

createSheetCircle( "Circle10", [ 3050, 200, 0 ], [ 0, 0, 1 ], 100 )
subtract( "SHEET1", [ "Circle10" ], False, True )

createSheetCircle( "Circle11", [ 3350, 200, 0 ], [ 0, 0, 1 ], 100 )
subtract( "SHEET1", [ "Circle11" ], False, True )

createSheetCircle( "Circle12", [ 3650, 200, 0 ], [ 0, 0, 1 ], 100 )
subtract( "SHEET1", [ "Circle12" ], False, True )





# DEFINE PROPERTIES FOR THE CONCRETE GEOMETRY AND MATERIAL
# TOTAL STRAIN FIXED CRACKING
addMaterial( "Concrete", "CONCR", "TSCR", [] )
setParameter( MATERIAL, "Concrete", "LINEAR/ELASTI/YOUNG", YOUNGSMOD )
setParameter( MATERIAL, "Concrete", "LINEAR/ELASTI/POISON", POISSONRATIO )

setParameter( MATERIAL, "Concrete", "MODTYP/TOTCRK", "FIXED" )   

setParameter( MATERIAL, "Concrete", "COMPRS/COMCRV", "PARABO" )    
#setParameter( "MATERIAL", "Concrete", "COMPRS/COMCRV", "MC2010" )  
# setParameter( "MATERIAL", "Concrete", "COMPRS/COMCRV", "CONSTA" )  
setParameter( MATERIAL, "Concrete", "COMPRS/COMSTR", FC )
setParameter( MATERIAL, "Concrete", "COMPRS/GC", GC )
setParameter( MATERIAL, "Concrete", "COMPRS/CONFIN/CNFCRV", "VECCHI" )
setParameter( MATERIAL, "Concrete", "COMPRS/REDUCT/REDCRV", "VC1993" )

# setParameter( MATERIAL, "Concrete", "TENSIL/TENCRV", "EXPONE" )    
setParameter( "MATERIAL", "Concrete", "TENSIL/TENCRV", "MC2010" )  
# setParameter( "MATERIAL", "Concrete", "TENSIL/CBSPEC", "GOVIND" )  
setParameter( "MATERIAL", "Concrete", "TENSIL/CBSPEC", "ROTS" )    
setParameter( MATERIAL, "Concrete", "TENSIL/TENSTR", FCT )
setParameter( MATERIAL, "Concrete", "TENSIL/GF1", GF ) 
setParameter( MATERIAL, "Concrete", "TENSIL/POISRE/POIRED", "DAMAGE" )   

setParameter( MATERIAL, "Concrete", "SHEAR/SHRCRV", "CONSTA" )
# setParameter( "MATERIAL", "Concrete", "SHEAR/SHRCRV", "DAMAGE" )  
setParameter( MATERIAL, "Concrete", "SHEAR/BETA", BETA )    

CONMATNAME = "Concrete"
addGeometry( CONMATNAME, "SHEET", "MEMBRA", [] )
setParameter( GEOMET, CONMATNAME, "THICK", WIDTH )

assignMaterial( CONMATNAME, "SHAPE", SHAPELIST[0:1] )
assignGeometry( CONMATNAME, "SHAPE", SHAPELIST[0:1] )






# DEFINE PROPERTIES FOR THE REINFORCEMENT GEOMETRY AND MATERIAL
setReinforcementAspects( ASTOPREINFORCEMENT1 )
setReinforcementAspects( ASTOPREINFORCEMENT2 )
setReinforcementAspects( ASBOTTOMREINFORCEMENT1 )
setReinforcementAspects( ASBOTTOMREINFORCEMENT2 )
setReinforcementAspects( ASSTIRR )
setReinforcementAspects( AS_VERT1 )
setReinforcementAspects( AS_VERT2 )
setReinforcementAspects( AS_VERT3 )
setReinforcementAspects( AS_VERT4 )
setReinforcementAspects( AS_VERT5 )
setReinforcementAspects( AS_VERT6 )
setReinforcementAspects( AS_VERT7 )
setReinforcementAspects( AS_VERT8 )
setReinforcementAspects( AS_VERT9 )
setReinforcementAspects( AS_VERT10 )
setReinforcementAspects( AS_VERT11 )
setReinforcementAspects( AS_VERT12 )
setReinforcementAspects( AS_VERT13 )
setReinforcementAspects( AS_VERT14 )
setReinforcementAspects( AS_VERT15 )
setReinforcementAspects( AS_HOR1 )
setReinforcementAspects( AS_HOR2 )
setReinforcementAspects( AS_HOR3 )
setReinforcementAspects( AS_HOR4 )
setReinforcementAspects( AS_HOR5 )
setReinforcementAspects( AS_HOR6 )
setReinforcementAspects( AS_HOR7 )
setReinforcementAspects( AS_HOR8 )
setReinforcementAspects( AS_HOR9 )
setReinforcementAspects( AS_HOR10 )
setReinforcementAspects( AS_HOR11 )
setReinforcementAspects( AS_HOR12 )
setReinforcementAspects( AS_HOR13 )
setReinforcementAspects( AS_HOR14 )
setReinforcementAspects( AS_HOR14 )
setReinforcementAspects( AS_HOR15 )
setReinforcementAspects( AS_HOR15 )
setReinforcementAspects( ASCABLE1 )
setReinforcementAspects( ASCABLE2 )
RMATNAME = "Steel reinforcement" 
SMATNAME = "Stirrups"  
R06MATNAME = "Steel reinforcement2" 
R10MATNAME = "Steel reinforcement3"  
R12MATNAME = "Steel reinforcement4"
RCABLEMATNAME = "Cable reinforcement"


# DEFINE PROPERTIES FOR THE STEEL GEOMETRY AND MATERIAL
# TOTAL STRAIN FIXED CRACKING
addMaterial( "Steelplate", "MCSTEL", "TRESCA", [] )   
setParameter( MATERIAL, "Steelplate", "TREPLA/YIELD", "VMISES" )
setParameter( MATERIAL, "Steelplate", "LINEAR/ELASTI/YOUNG", ES_STEEL )
setParameter( MATERIAL, "Steelplate", "LINEAR/ELASTI/POISON", POISSON_STEEL ) 
setParameter( MATERIAL, "Steelplate", "TREPLA/YLDSTR", FY_Steel_Plate ) 

STEELMATNAME = "Steelplate"
addGeometry( STEELMATNAME, "SHEET", "MEMBRA", [] )
setParameter( GEOMET, STEELMATNAME, "THICK", WIDTH )

assignMaterial( STEELMATNAME, "SHAPE", SHAPELIST[1:9] )
assignGeometry( STEELMATNAME, "SHAPE", SHAPELIST[1:9] )

addMaterial( "Steelbeam", "MCSTEL", "TRESCA", [] )   
setParameter( MATERIAL, "Steelbeam", "TREPLA/YIELD", "VMISES" )
setParameter( MATERIAL, "Steelbeam", "LINEAR/ELASTI/YOUNG", ES_STEELBEAM )
setParameter( MATERIAL, "Steelbeam", "LINEAR/ELASTI/POISON", POISSON_STEEL ) 
setParameter( MATERIAL, "Steelbeam", "TREPLA/YLDSTR", FY_Steel_Beam ) 

STEELMATNAME = "Steelbeam"
addGeometry( STEELMATNAME, "SHEET", "MEMBRA", [] )
setParameter( GEOMET, STEELMATNAME, "THICK", WIDTH )

assignMaterial( STEELMATNAME, "SHAPE", SHAPELIST[9:13] )
assignGeometry( STEELMATNAME, "SHAPE", SHAPELIST[9:13] )


#SMAX AND EPSPLMAX ARE THE PARAMETERS FOR THE NONLINEAR HARDENING RELATION BETWEEN YIELD STRESS AND PLASTIC STRAIN   

SMAX04 = FY04 + EHTOT*(EPSMAX - FY04/ES_REINFORCEMENT)
EPSPLMAX04 = EPSMAX*(1-EHTOT/ES_REINFORCEMENT) + FY04/ES_REINFORCEMENT*(EHTOT/ES_REINFORCEMENT - 1)
SMAX06 = FY06 + EHTOT*(EPSMAX - FY06/ES_REINFORCEMENT)
EPSPLMAX06 = EPSMAX*(1-EHTOT/ES_REINFORCEMENT) + FY06/ES_REINFORCEMENT*(EHTOT/ES_REINFORCEMENT - 1)
SMAX10 = FY10 + EHTOT*(EPSMAX - FY10/ES_REINFORCEMENT)
EPSPLMAX10 = EPSMAX*(1-EHTOT/ES_REINFORCEMENT) + FY10/ES_REINFORCEMENT*(EHTOT/ES_REINFORCEMENT - 1)
SMAX12 = FY12 + EHTOT*(EPSMAX - FY12/ES_REINFORCEMENT)
EPSPLMAX12 = EPSMAX*(1-EHTOT/ES_REINFORCEMENT) + FY12/ES_REINFORCEMENT*(EHTOT/ES_REINFORCEMENT - 1)


addMaterial( RMATNAME, "REINFO", "VMISES", [] )
setParameter( MATERIAL, RMATNAME, "LINEAR/ELASTI/YOUNG", ES_REINFORCEMENT )
setParameter( MATERIAL, RMATNAME, "PLASTI/YLDTYP", "KAPSIG" )
setParameter( MATERIAL, RMATNAME, "PLASTI/HARDI2/KAPSIG", [] )
setParameter( MATERIAL, RMATNAME, "PLASTI/HARDI2/KAPSIG", [ 0, FY12, EPSPLMAX12, SMAX12 ] )

addMaterial( R06MATNAME, "REINFO", "VMISES", [] )
setParameter( MATERIAL, R06MATNAME, "LINEAR/ELASTI/YOUNG", ES_REINFORCEMENT )
setParameter( MATERIAL, R06MATNAME, "PLASTI/YLDTYP", "KAPSIG" )
setParameter( MATERIAL, R06MATNAME, "PLASTI/HARDI2/KAPSIG", [] )
setParameter( MATERIAL, R06MATNAME, "PLASTI/HARDI2/KAPSIG", [ 0, FY06, EPSPLMAX06, SMAX06 ] )

addMaterial( R10MATNAME, "REINFO", "VMISES", [] )
setParameter( MATERIAL, R10MATNAME, "LINEAR/ELASTI/YOUNG", ES_REINFORCEMENT )
setParameter( MATERIAL, R10MATNAME, "PLASTI/YLDTYP", "KAPSIG" )
setParameter( MATERIAL, R10MATNAME, "PLASTI/HARDI2/KAPSIG", [] )
setParameter( MATERIAL, R10MATNAME, "PLASTI/HARDI2/KAPSIG", [ 0, FY10, EPSPLMAX10, SMAX10 ] )

addMaterial( RCABLEMATNAME, "REINFO", "VMISES", [] )
setParameter( MATERIAL, RCABLEMATNAME, "LINEAR/ELASTI/YOUNG", ES_REINFORCEMENT )
setParameter( MATERIAL, RCABLEMATNAME, "PLASTI/YLDTYP", "KAPSIG" )
setParameter( MATERIAL, RCABLEMATNAME, "PLASTI/HARDI2/KAPSIG", [] )
setParameter( MATERIAL, RCABLEMATNAME, "PLASTI/HARDI2/KAPSIG", [ 0, FY10, EPSPLMAX10, SMAX10 ] )

addMaterial( R12MATNAME, "REINFO", "VMISES", [] )
setParameter( MATERIAL, R12MATNAME, "LINEAR/ELASTI/YOUNG", ES_REINFORCEMENT )
setParameter( MATERIAL, R12MATNAME, "PLASTI/YLDTYP", "KAPSIG" )
setParameter( MATERIAL, R12MATNAME, "PLASTI/HARDI2/KAPSIG", [] )
setParameter( MATERIAL, R12MATNAME, "PLASTI/HARDI2/KAPSIG", [ 0, FY12, EPSPLMAX12, SMAX12 ] )

addMaterial( SMATNAME, "REINFO", "VMISES", [] )
setParameter( MATERIAL, SMATNAME, "LINEAR/ELASTI/YOUNG", ES_REINFORCEMENT )
setParameter( MATERIAL, SMATNAME, "PLASTI/YLDTYP", "KAPSIG" )
setParameter( MATERIAL, SMATNAME, "PLASTI/HARDI2/KAPSIG", [] )
setParameter( MATERIAL, SMATNAME, "PLASTI/HARDI2/KAPSIG", [ 0, FY04, EPSPLMAX04, SMAX04 ] )



addGeometry( RMATNAME, "RELINE", "REBAR", [] )
setParameter( GEOMET, RMATNAME, "CROSSE", ASTOP1 )  
addGeometry( R12MATNAME, "RELINE", "REBAR", [] )
setParameter( GEOMET, R12MATNAME, "CROSSE", ASVERT3 )  
addGeometry( R06MATNAME, "RELINE", "REBAR", [] )
setParameter( GEOMET, R06MATNAME, "CROSSE", ASVERT1 )
addGeometry( R10MATNAME, "RELINE", "REBAR", [] )
setParameter( GEOMET, R10MATNAME, "CROSSE", ASVERT2 )
addGeometry( RCABLEMATNAME, "RELINE", "REBAR", [] )
setParameter( GEOMET, RCABLEMATNAME, "CROSSE", ASCABLE )
addGeometry( SMATNAME, "RELINE", "REBAR", [] )
setParameter( GEOMET, SMATNAME, "CROSSE", ASSTIRRUP )



assignMaterial( RMATNAME, "SHAPE", ASTOPREINFORCEMENT1 )
assignGeometry( RMATNAME, "SHAPE", ASTOPREINFORCEMENT1 )
assignMaterial( RMATNAME, "SHAPE", ASTOPREINFORCEMENT2 )
assignGeometry( RMATNAME, "SHAPE", ASTOPREINFORCEMENT2 )
assignMaterial( RMATNAME, "SHAPE", ASBOTTOMREINFORCEMENT1 )
assignGeometry( RMATNAME, "SHAPE", ASBOTTOMREINFORCEMENT1 )
assignMaterial( RMATNAME, "SHAPE", ASBOTTOMREINFORCEMENT2 )
assignGeometry( RMATNAME, "SHAPE", ASBOTTOMREINFORCEMENT2 )
assignMaterial( RCABLEMATNAME, "SHAPE", ASCABLE1 )
assignGeometry( RCABLEMATNAME, "SHAPE", ASCABLE1 )
assignMaterial( RCABLEMATNAME, "SHAPE", ASCABLE2 )
assignGeometry( RCABLEMATNAME, "SHAPE", ASCABLE2 )
assignMaterial( R12MATNAME, "SHAPE", AS_VERT2 )
assignGeometry( R12MATNAME, "SHAPE", AS_VERT2 )
assignMaterial( R12MATNAME, "SHAPE", AS_VERT3 )
assignGeometry( R12MATNAME, "SHAPE", AS_VERT3 )
assignMaterial( SMATNAME, "SHAPE", ASSTIRR )
assignGeometry( SMATNAME, "SHAPE", ASSTIRR )
assignMaterial( SMATNAME, "SHAPE", AS_HOR2 )
assignGeometry( SMATNAME, "SHAPE", AS_HOR2 )
assignMaterial( SMATNAME, "SHAPE", AS_HOR3 )
assignGeometry( SMATNAME, "SHAPE", AS_HOR3 )
assignMaterial( SMATNAME, "SHAPE", AS_HOR4 )
assignGeometry( SMATNAME, "SHAPE", AS_HOR4 )
assignMaterial( SMATNAME, "SHAPE", AS_HOR5 )
assignGeometry( SMATNAME, "SHAPE", AS_HOR5 )
assignMaterial( SMATNAME, "SHAPE", AS_HOR6 )
assignGeometry( SMATNAME, "SHAPE", AS_HOR6 )
assignMaterial( SMATNAME, "SHAPE", AS_HOR7 )
assignGeometry( SMATNAME, "SHAPE", AS_HOR7 )
assignMaterial( SMATNAME, "SHAPE", AS_HOR8 )
assignGeometry( SMATNAME, "SHAPE", AS_HOR8 )
assignMaterial( SMATNAME, "SHAPE", AS_HOR9 )
assignGeometry( SMATNAME, "SHAPE", AS_HOR9 )
assignMaterial( SMATNAME, "SHAPE", AS_HOR10 )
assignGeometry( SMATNAME, "SHAPE", AS_HOR10 )
assignMaterial( SMATNAME, "SHAPE", AS_HOR11 )
assignGeometry( SMATNAME, "SHAPE", AS_HOR11 )
assignMaterial( SMATNAME, "SHAPE", AS_HOR12 )
assignGeometry( SMATNAME, "SHAPE", AS_HOR12 )
assignMaterial( SMATNAME, "SHAPE", AS_HOR13 )
assignGeometry( SMATNAME, "SHAPE", AS_HOR13 )
assignMaterial( SMATNAME, "SHAPE", AS_HOR14 )
assignGeometry( SMATNAME, "SHAPE", AS_HOR14 )
assignMaterial( R06MATNAME, "SHAPE", AS_HOR1 )
assignGeometry( R06MATNAME, "SHAPE", AS_HOR1 )
assignMaterial( R06MATNAME, "SHAPE", AS_HOR15 )
assignGeometry( R06MATNAME, "SHAPE", AS_HOR15 )
assignMaterial( R06MATNAME, "SHAPE", AS_VERT1 )
assignGeometry( R06MATNAME, "SHAPE", AS_VERT1 )
assignMaterial( R06MATNAME, "SHAPE", AS_VERT4 )
assignGeometry( R06MATNAME, "SHAPE", AS_VERT4 )
assignMaterial( R10MATNAME, "SHAPE", AS_VERT5 )
assignGeometry( R10MATNAME, "SHAPE", AS_VERT5 )
assignMaterial( R10MATNAME, "SHAPE", AS_VERT6 )
assignGeometry( R10MATNAME, "SHAPE", AS_VERT6 )
assignMaterial( R10MATNAME, "SHAPE", AS_VERT7 )
assignGeometry( R10MATNAME, "SHAPE", AS_VERT7 )
assignMaterial( R10MATNAME, "SHAPE", AS_VERT8 )
assignGeometry( R10MATNAME, "SHAPE", AS_VERT8 )
assignMaterial( R10MATNAME, "SHAPE", AS_VERT9 )
assignGeometry( R10MATNAME, "SHAPE", AS_VERT9 )
assignMaterial( R10MATNAME, "SHAPE", AS_VERT10 )
assignGeometry( R10MATNAME, "SHAPE", AS_VERT10 )
assignMaterial( R10MATNAME, "SHAPE", AS_VERT11 )
assignGeometry( R10MATNAME, "SHAPE", AS_VERT11 )
assignMaterial( R10MATNAME, "SHAPE", AS_VERT12 )
assignGeometry( R10MATNAME, "SHAPE", AS_VERT12 )
assignMaterial( R10MATNAME, "SHAPE", AS_VERT13 )
assignGeometry( R10MATNAME, "SHAPE", AS_VERT13 )
assignMaterial( R10MATNAME, "SHAPE", AS_VERT14 )
assignGeometry( R10MATNAME, "SHAPE", AS_VERT14 )
assignMaterial( R10MATNAME, "SHAPE", AS_VERT15 )
assignGeometry( R10MATNAME, "SHAPE", AS_VERT15 )



# DEFINE SUPPORTS BC

createPointSupport( "LEFTSUPPORT", "Geometry support set 1" )
setParameter( "GEOMETRYSUPPORT", "LEFTSUPPORT", "AXES", [ 1, 2 ] )
setParameter( "GEOMETRYSUPPORT", "LEFTSUPPORT", "TRANSL", [ 1, 1, 1 ] )
setParameter( "GEOMETRYSUPPORT", "LEFTSUPPORT", "ROTATI", [ 0, 0, 0 ] )


createPointSupport( "RIGHTSUPPORT", "Geometry support set 1" )
setParameter( "GEOMETRYSUPPORT", "RIGHTSUPPORT", "AXES", [ 1, 2 ] )
setParameter( "GEOMETRYSUPPORT", "RIGHTSUPPORT", "TRANSL", [ 0, 1, 1 ] )
setParameter( "GEOMETRYSUPPORT", "RIGHTSUPPORT", "ROTATI", [ 0, 0, 0 ] )


#LOADS

createPointSupport( "LOADSUPPORT", "Geometry support set 1" )
setParameter( "GEOMETRYSUPPORT", "LOADSUPPORT", "AXES", [ 1, 2 ] )
setParameter( "GEOMETRYSUPPORT", "LOADSUPPORT", "TRANSL", [ 0, 1, 0 ] )
setParameter( "GEOMETRYSUPPORT", "LOADSUPPORT", "ROTATI", [ 0, 0, 0 ] )


COORDLEFTSUPPORT = [ XSUPPORTCOORD[1] , YSUPPORTCOORD[1], 0]
COORDRIGHTSUPPORT = [ XSUPPORTCOORD[4] , YSUPPORTCOORD[1] , 0 ]
COORDLOADSUPPORT1 = [ XBEAMCOORD[2] , YBEAMCOORD[5] , 0 ]
COORDLOADSUPPORT2 = [ XBEAMCOORD[5] , YBEAMCOORD[5] , 0 ]



attach( "GEOMETRYSUPPORT", "LEFTSUPPORT", SHAPELIST[2], [COORDLEFTSUPPORT] )
attach( "GEOMETRYSUPPORT", "RIGHTSUPPORT", SHAPELIST[4], [COORDRIGHTSUPPORT] )
attach( "GEOMETRYSUPPORT", "LOADSUPPORT", SHAPELIST[10], [COORDLOADSUPPORT1] )
attach( "GEOMETRYSUPPORT", "LOADSUPPORT", SHAPELIST[12], [COORDLOADSUPPORT2] )



#2) DISPLACEMENT CONTROL (attach supports at loading plate)
addSet( GEOMETRYLOADSET, "Geometry load case 2" )
showView( "GEOM" )
createPointLoad( "Displacement control", "Geometry load case 2" )
setParameter( GEOMETRYLOAD, "Displacement control", "LODTYP", "DEFORM" )
setParameter( GEOMETRYLOAD, "Displacement control", "DEFORM/TR/VALUE", PRESCRIBEDDISPLACEMENT )
setParameter( GEOMETRYLOAD, "Displacement control", "DEFORM/TR/DIRECT", 2 )
attach( GEOMETRYLOAD, "Displacement control", "SHEET10", [[ 1250, 545, 0 ]] )   
attach( GEOMETRYLOAD, "Displacement control", "SHEET12", [[ 2750, 545, 0 ]] ) 






#INTERFACE BETWEEN LOADING PLATE & BEAM_EDGE
addMaterial( "Interface_SOFT_EDGE", "INTERF", "ELASTI", [] )
setParameter( "MATERIAL", "Interface_SOFT_EDGE", "LINEAR/IFTYP", "LIN2D" )
setParameter( "MATERIAL", "Interface_SOFT_EDGE", "LINEAR/ELAS2/DSNY", INTERFACE_NORMALSTIFFNESS )
setParameter( "MATERIAL", "Interface_SOFT_EDGE", "LINEAR/ELAS2/DSSX", INTERFACE_ZEROTANGENTIALSTIFFNESS )
setParameter( "MATERIAL", "Interface_SOFT_EDGE", "LINEAR/ELAS2/DSNY", INTERFACE_NORMALSTIFFNESS )
addGeometry( "Element geometry 10", "LINE", "STLIIF", [] )
rename( "GEOMET", "Element geometry 10", "THICKNESS" )
setParameter( "GEOMET", "THICKNESS", "LIFMEM/THICK", 150 )
setParameter( "GEOMET", "THICKNESS", "LOCAXS", True )
setParameter( "GEOMET", "THICKNESS", "LOCAXS", False )
setGeometryFunction( "THICKNESS", "LIFMEM/THICK", "" )
setParameter( "GEOMET", "THICKNESS", "LIFMEM/THICK", 150 )
createConnection( "Interface_SOFT_EDGE", "INTER", "SHAPEEDGE" )
setParameter( "GEOMETRYCONNECTION", "Interface_SOFT_EDGE", "MODE", "AUTO" )
attachTo( "GEOMETRYCONNECTION", "Interface_SOFT_EDGE", "SOURCE", "SHEET6", [[ 800, 400, 0 ]] )
attachTo( "GEOMETRYCONNECTION", "Interface_SOFT_EDGE", "SOURCE", "SHEET7", [[ 1700, 400, 0 ]] )
attachTo( "GEOMETRYCONNECTION", "Interface_SOFT_EDGE", "SOURCE", "SHEET8", [[ 2300, 400, 0 ]] )
attachTo( "GEOMETRYCONNECTION", "Interface_SOFT_EDGE", "SOURCE", "SHEET9", [[ 3200, 400, 0 ]] )
setElementClassType( "GEOMETRYCONNECTION", "Interface_SOFT_EDGE", "STLIIF" )
assignMaterial( "Interface_SOFT_EDGE", "GEOMETRYCONNECTION", "Interface_SOFT_EDGE" )
assignGeometry( "THICKNESS", "GEOMETRYCONNECTION", "Interface_SOFT_EDGE" )
setParameter( "GEOMETRYCONNECTION", "Interface_SOFT_EDGE", "FLIP", False )
resetElementData( "GEOMETRYCONNECTION", "Interface_SOFT_EDGE" )



# MESHING
setElementSize( SHAPELIST, ELEMENTSIZE )
setElementClassType( SHAPELIST, "MEMBRA" )

generateMesh(shapes())

addElementData( "Element data 1" )
setParameter( DATA, "Element data 1", "INTEGR", "HIGH" )  
assignElementData( "Element data 1", ELEMENT, SHAPELIST )


# SET UP NON-LINEAR ANALYSIS
analysis = "Nonlinear analysis"
command  = "Structural nonlinear"
addAnalysis( analysis )
addAnalysisCommand( analysis, "NONLIN", command )

setAnalysisCommandDetail( analysis, command, "EXECUT(1)/ITERAT/METHOD/METNAM", "NEWTON" ) 
setAnalysisCommandDetail( analysis, command, "EXECUT(1)/ITERAT/METHOD/NEWTON/TYPNAM", "REGULA" )    
setAnalysisCommandDetail( analysis, command, "EXECUT(1)/ITERAT/MAXITE", 40 )             
setAnalysisCommandDetail( analysis, command, "EXECUT(1)/ITERAT/CONVER/FORCE", True )
setAnalysisCommandDetail( analysis, command, "EXECUT(1)/ITERAT/CONVER/ENERGY", True )
setAnalysisCommandDetail( analysis, command, "EXECUT(1)/ITERAT/CONVER/DISPLA", False )
setAnalysisCommandDetail( analysis, command, "EXECUT(1)/ITERAT/CONVER/FORCE/TOLCON", 0.01 )  
setAnalysisCommandDetail( analysis, command, "EXECUT(1)/ITERAT/CONVER/FORCE/NOCONV", "CONTIN" )
setAnalysisCommandDetail( analysis, command, "EXECUT(1)/ITERAT/CONVER/ENERGY/TOLCON", 0.001 )  
setAnalysisCommandDetail( analysis, command, "EXECUT(1)/ITERAT/CONVER/ENERGY/NOCONV", "CONTIN" )  
setAnalysisCommandDetail( analysis, command, "EXECUT(1)/ITERAT/CONVER/SIMULT", False )
#addAnalysisCommandDetail( analysis, command, "EXECUT(1)/SOLVE/CHOLES" ) 
addAnalysisCommandDetail( "Nonlinear analysis", "Structural nonlinear", "EXECUT(1)/ITERAT/LINESE" )    
setAnalysisCommandDetail( "Nonlinear analysis", "Structural nonlinear", "EXECUT(1)/ITERAT/LINESE", True )      
setAnalysisCommandDetail( "Nonlinear analysis", "Structural nonlinear", "EXECUT(1)/ITERAT/LINESE/MAXLS", 10 )      
# addAnalysisCommandDetail( "Nonlinear analysis", "Structural nonlinear", "EXECUT(1)/LOAD/STEPS/EXPLIC/ARCLEN" )       
# setAnalysisCommandDetail( "Nonlinear analysis", "Structural nonlinear", "EXECUT(1)/LOAD/STEPS/EXPLIC/ARCLEN", True )  




setAnalysisCommandDetail( analysis, command, "EXECUT(1)/LOAD/STEPS/EXPLIC/SIZES", "0.01(100)" )
setAnalysisCommandDetail( analysis, command, "EXECUT(1)/LOGGIN/REPORT/AMOUNT", "FULL" )
setAnalysisCommandDetail( analysis, command, "EXECUT(1)/LOGGIN/REPORT/TERMIN", "STEP" )
setAnalysisCommandDetail( analysis, command, "OUTPUT(1)/SELTYP", "USER" )
addAnalysisCommandDetail( analysis, command, "OUTPUT(1)/USER" )
addAnalysisCommandDetail( analysis, command, "OUTPUT(1)/USER/DISPLA(1)/TOTAL/TRANSL/GLOBAL" )
addAnalysisCommandDetail( analysis, command, "OUTPUT(1)/USER/FORCE(1)/REACTI/TRANSL/GLOBAL" )
# addAnalysisCommandDetail( analysis, command, "OUTPUT(1)/USER/DISPLA" )
# addAnalysisCommandDetail( analysis, command, "OUTPUT(1)/USER/FORCE" )
addAnalysisCommandDetail( analysis, command, "OUTPUT(1)/USER/STRAIN(1)" )
setAnalysisCommandDetail( analysis, command, "OUTPUT(1)/USER/STRAIN(1)/TOTAL/GREEN/GLOBAL/LOCATI", "INTPNT" )   
addAnalysisCommandDetail( analysis, command, "OUTPUT(1)/USER/STRAIN(2)/TOTAL/GREEN/PRINCI" )
setAnalysisCommandDetail( analysis, command, "OUTPUT(1)/USER/STRAIN(2)/TOTAL/GREEN/PRINCI/LOCATI", "INTPNT" )
addAnalysisCommandDetail( analysis, command, "OUTPUT(1)/USER/STRAIN(3)/CRACK/GREEN" )
addAnalysisCommandDetail( analysis, command, "OUTPUT(1)/USER/STRESS" )
setAnalysisCommandDetail( analysis, command, "OUTPUT(1)/USER/STRESS(1)/TOTAL/CAUCHY/GLOBAL/LOCATI", "INTPNT" )
addAnalysisCommandDetail( analysis, command, "OUTPUT(1)/USER/STRESS(2)/TOTAL/CAUCHY/PRINCI" )
setAnalysisCommandDetail( analysis, command, "OUTPUT(1)/USER/STRESS(2)/TOTAL/CAUCHY/PRINCI/LOCATI", "INTPNT" )
addAnalysisCommandDetail( "Nonlinear analysis", "Structural nonlinear", "OUTPUT(1)/USER/STRAIN(4)/CRKWDT/GREEN/GLOBAL" )       
setAnalysisCommandDetail( "Nonlinear analysis", "Structural nonlinear", "OUTPUT(1)/USER/STRAIN(4)/CRKWDT/GREEN/GLOBAL/LOCATI", "INTPNT" )
addAnalysisCommandDetail( "Nonlinear analysis", "Structural nonlinear", "OUTPUT(1)/USER/STRAIN(5)/CRKSUM/GREEN/GLOBAL" )           
setAnalysisCommandDetail( "Nonlinear analysis", "Structural nonlinear", "OUTPUT(1)/USER/STRAIN(5)/CRKSUM/GREEN/GLOBAL/LOCATI", "INTPNT" )
addAnalysisCommandDetail( "Nonlinear analysis", "Structural nonlinear", "OUTPUT(1)/USER/DISPLA(2)/INCREM/TRANSL/GLOBAL" )
addAnalysisCommandDetail( "Nonlinear analysis", "Structural nonlinear", "OUTPUT(1)/USER/DISPLA(3)/INCREM/TRANSL/LOCAL" )




# EXPORT .DAT- AND .DCF-FILE
exportModel( "CONCRETE_BEAM_RCxcb_2D_CONSTANT_SHEAR_RETENTION.dat", 10 )
saveAnalysisCommands( analysis, "CONCRETE_BEAM_RCxcb_2D_CONSTANT_SHEAR_RETENTION.dcf")



# RUN ANALYSIS
runSolver( analysis )
# showView( "RESULT" )
# setViewPoint( "TOP" )
# setResultPlot( "contours", "Cauchy Total Stresses/mappedintegrationpoint", "S2" )
# setViewSettingValue( "result view setting", "CONTOU/COUNT/NUMLVL", 20 )



# #FIND LOAD DISPLACEMENT CURVE (LOAD = Support reactions)
DISPCOORD = [(XCOORD[0]+SPACING2000),YCOORD[0], 0 ]  
DISPNODE = findNearestNodes([DISPCOORD])
highlight(NODE,DISPNODE)
DISPNODELIST = [DISPNODE[0]]

FORCENODE1 = findNearestNodes([COORDLEFTSUPPORT])
FORCENODE2 = findNearestNodes([COORDRIGHTSUPPORT])
FORCENODES = [FORCENODE1[0],FORCENODE2[0]]
highlight(NODE,FORCENODES)

DISPLACEMENTS = []
LASTCASE = len(resultCases(analysis,''))
for i in range(0,LASTCASE):
    DISPLACEMENTS.append(resultData([analysis,"Output",resultCases(analysis,"Output")[i],"Displacements","TDtY"],DISPNODE)[0][1])

REACTIONS = []
FORCE = 0
for i in range(0,LASTCASE):
    for j in FORCENODES:
        FORCE = FORCE + resultData([analysis,"Output",resultCases(analysis,"Output")[i],"Reaction Forces","FBY"],(j,))[0][1]
    REACTIONS.append(FORCE)
    FORCE = 0

f = open('LOADDISP_Model1_RCxcb_2D_CONSTANT_SHEAR_RETENTION.TXT','w')
for i in range(0,len(REACTIONS)):
    f.write('{0:20.6f} {1:20.6f}\n'.format(DISPLACEMENTS[i],REACTIONS[i]))

f.close()


# # FIND SUPPORT FORCE TOTAL LOAD CURVE
SUPPORTNODE = findNearestNodes([COORDLEFTSUPPORT])
FORCENODE1 = findNearestNodes([COORDLEFTSUPPORT])
FORCENODE2 = findNearestNodes([COORDRIGHTSUPPORT])
FORCENODES = [FORCENODE1[0],FORCENODE2[0]]
highlight(NODE,FORCENODES)

SUPPORTLOAD = []
LASTCASE = len(resultCases(analysis,''))
for i in range(0,LASTCASE):
    SUPPORTLOAD.append(resultData([analysis,"Output",resultCases(analysis,"Output")[i],"Reaction Forces","FBY"],SUPPORTNODE)[0][1])

REACTIONS = []
FORCE = 0
for i in range(0,LASTCASE):
    for j in FORCENODES:
        FORCE = FORCE + resultData([analysis,"Output",resultCases(analysis,"Output")[i],"Reaction Forces","FBY"],(j,))[0][1]
    REACTIONS.append(FORCE)
    FORCE = 0

f = open('SUPPLOAD_Model1_RCxcb_2D_CONSTANT_SHEAR_RETENTION.TXT','w')
for i in range(0,len(REACTIONS)):
    f.write('{0:20.6f} {1:20.6f}\n'.format(SUPPORTLOAD[i],REACTIONS[i]))

f.close()