

# OPEN NEW PROJECT
closeProject()
newProject( "CONCRETE_BEAM_RCxcb_3D_EXPONENTIAL", 10 )
setModelAnalysisAspects( [ "STRUCT" ] )
setModelDimension( "3D" )
#setDefaultMeshOrder( "LINEAR" )     
setDefaultMeshOrder( "QUADRATIC" )	 
setDefaultMesherType( "HEXQUAD" )
setUnit( "LENGTH", "MM" )
setUnit( "FORCE", "N" )


# INITIALIZE SHAPE LIST AND SHAPE NUMBERING
SHAPELIST = []
SHAPENUMBER = 1
SELTOL = 0.01	

from TOP_FUNC import V_TOP as V_TOP
import os
from math import pi


# SET PARAMETERS
LEFTSUPPORT = 200
RIGHTSUPPORT = 200
LOADPLATE1 = 100
LOADPLATE2 = 100
LOADPLATE3 = 100
LOADPLATE4 = 100
VERTDIST = 50
VERTDIST2 = 300
PLATETHICKNESS = 40
HEIGHT = 400
WIDTH = 150
SPACING20 = 20
SPACING30 = 30
SPACING40 = 40
SPACING45 = 45
SPACING50 = 50
SPACING75 = 75
SPACING80 = 80
SPACING100 = 100
SPACING150 = 150
SPACING200 = 200
SPACING250 = 250
SPACING300 = 300
SPACING400 = 400
SPACING500 = 500
SPACING550 = 550
SPACING700 = 700
SPACING750 = 750
SPACING800 = 800
SPACING2000 = 2000
SPACING3600 = 3600
SPACING4000 = 4000
SECONDARY_BEAM_THICKNESS = 100
SPANWITH = 3800



PRESCRIBEDDISPLACEMENT = -200  


#REINFORCEMENT DIAMETER (ALL)
DIAMTWELVE = 12
DIAMTEN = 10
DIAMEIGHT = 8
DIAMSIX = 6
DIAMFOUR = 4


#REINFORCEMENT HORIZONTAL LONGITUDINAL 
ASTOP1 = (pi/4*DIAMTWELVE**2)
ASTOP2 = (pi/4*DIAMTWELVE**2)
ASBOTTOM1 = (pi/4*DIAMTWELVE**2)
ASBOTTOM2 = (pi/4*DIAMTWELVE**2)

#REINFORCEMENT VERTICAL 
ASVERT1 = (pi/4*DIAMSIX**2)
ASVERT2 = (pi/4*DIAMTEN**2)
ASVERT3 = (pi/4*DIAMTWELVE**2)


#REINFORCEMENT SHEAR/STIRRUPS TOP/BOTTOM
ASSTIRRUP = (pi/4*DIAMFOUR**2)

#REINFORCEMENT CABEL 
ASCABLE = (pi/4*DIAMTEN**2)



COVER = 25


#SPACING BETWEEN STIRRUPS 
SHORTSPACING = 40            	
LONGSPACING = 80            	


#ELEMENTSIZE
ELEMENTSIZE = HEIGHT/12   							


#MATERIAL PROPERTIES CONCRETE 
YOUNGSMOD = 30290			# Eci (youngs modulus after 28 days) = Ec0*(fcm/fcm0)^1/3 (Ec0=22000 N/mm2 , fcm0 = 10 MPa)
POISSONRATIO = 0.15
FCT = 2.0681  #fctm			# Tensile strength (mean)(0.3*fck^2/3 = 0.3*(18,1^2/3)) 
FC = 26.1   #fcm           	# Compressive strength (here sylinder) according to technical paper 
GF = 0.1313					# Fracture Energy (73*fcm^0.18)/1000 = 
GC = 32.825    				# Compressive fracture energy (250*GF) 
BETA = 0.1					 


#MATERIAL PROPERTIES STEEL 
FY12= 550
FY10= 476
FY08= 480
FY06= 520
FY04= 520

FY_Steel_Plate = 355
FY_Steel_Beam = 355
ES_REINFORCEMENT= 200000.0
EHTOT = 4000      
EPSMAX = 0.1        
ES_STEEL = 210000
ES_STEELBEAM = 210000
POISSON_STEEL = 0.3
INTERFACE_NORMALSTIFFNESS = ((1000)*(ES_STEEL/ELEMENTSIZE))
INTERFACE_TANGENTIALSTIFFNESS = (INTERFACE_NORMALSTIFFNESS/10)
INTERFACE_ZEROTANGENTIALSTIFFNESS = (1*(10**(-4)))

# ESTABLISH LISTS WITH COORDINATES
XCOORD = [0]
XCOORD.append(XCOORD[0]+SPACING4000)


YCOORD = [0]
YCOORD.append(YCOORD[0]+SPACING150)


ZCOORD = [0]
ZCOORD.append(ZCOORD[0]+SPACING400)



#ESTABLISH LIST WITH COORDINATES FOR SUPPORT PLATE 
XSUPPORTCOORD = [0]
XSUPPORTCOORD.append(XSUPPORTCOORD[0]+LEFTSUPPORT/2)
XSUPPORTCOORD.append(XSUPPORTCOORD[1]+LEFTSUPPORT/2)
XSUPPORTCOORD.append(XSUPPORTCOORD[2]+SPACING3600)
XSUPPORTCOORD.append(XSUPPORTCOORD[3]+RIGHTSUPPORT/2)
XSUPPORTCOORD.append(XSUPPORTCOORD[4]+RIGHTSUPPORT/2)



YSUPPORTCOORD = [0]
YSUPPORTCOORD.append(YSUPPORTCOORD[0]+SPACING75)
YSUPPORTCOORD.append(YSUPPORTCOORD[1]+SPACING75)

ZSUPPORTCOORD = [0]
ZSUPPORTCOORD.append(ZSUPPORTCOORD[0]-PLATETHICKNESS) 


#ESTABLISH LIST WITH COORDINATES FOR LOAD PLATE 
XLOADCOORD = [0]
XLOADCOORD.append(XLOADCOORD[0]+SPACING750)
XLOADCOORD.append(XLOADCOORD[1]+LOADPLATE1)
XLOADCOORD.append(XLOADCOORD[2]+SPACING800)
XLOADCOORD.append(XLOADCOORD[3]+LOADPLATE2)
XLOADCOORD.append(XLOADCOORD[4]+SPACING500)
XLOADCOORD.append(XLOADCOORD[5]+LOADPLATE3)
XLOADCOORD.append(XLOADCOORD[6]+SPACING800)
XLOADCOORD.append(XLOADCOORD[7]+LOADPLATE4)
XLOADCOORD.append(XLOADCOORD[8]+SPACING750)


YLOADCOORD = [0]
YLOADCOORD.append(YLOADCOORD[0]+SPACING150)


ZLOADCOORD = [0]
ZLOADCOORD.append(ZLOADCOORD[0]+VERTDIST)
ZLOADCOORD.append(ZLOADCOORD[1]+VERTDIST2)
ZLOADCOORD.append(ZLOADCOORD[2]+VERTDIST)
ZLOADCOORD.append(ZLOADCOORD[3]+PLATETHICKNESS) 

#ESTABLISH LIST WITH COORDINATES FOR SECONDARY_BEAM

XBEAMCOORD = [0]
XBEAMCOORD.append(XBEAMCOORD[0]+SPACING700)
XBEAMCOORD.append(XBEAMCOORD[1]+SPACING550)
XBEAMCOORD.append(XBEAMCOORD[2]+SPACING550)
XBEAMCOORD.append(XBEAMCOORD[3]+SPACING400)
XBEAMCOORD.append(XBEAMCOORD[4]+SPACING550)
XBEAMCOORD.append(XBEAMCOORD[5]+SPACING550)
XBEAMCOORD.append(XBEAMCOORD[6]+SPACING700)

YBEAMCOORD = [0]
YBEAMCOORD.append(YBEAMCOORD[0]+SPACING150)

ZBEAMCOORD = [0]
ZBEAMCOORD.append(ZBEAMCOORD[0]+VERTDIST)
ZBEAMCOORD.append(ZBEAMCOORD[1]+VERTDIST2)
ZBEAMCOORD.append(ZBEAMCOORD[2]+VERTDIST)
ZBEAMCOORD.append(ZBEAMCOORD[3]+PLATETHICKNESS) 
ZBEAMCOORD.append(ZBEAMCOORD[4]+SECONDARY_BEAM_THICKNESS)



# CREATE GEOMETRY
SHAPENUMBER = 1
SHAPELIST = []
SHAPENUMBER,SHAPELIST = V_TOP(1,1,1,1,1,1,SHAPENUMBER,SHAPELIST,XCOORD,YCOORD,ZCOORD,createBlock) 
SHAPENUMBER,SHAPELIST = V_TOP(1,1,0,2,2,1,SHAPENUMBER,SHAPELIST,XSUPPORTCOORD,YSUPPORTCOORD,ZSUPPORTCOORD,createBlock) 
SHAPENUMBER,SHAPELIST = V_TOP(4,1,0,2,2,1,SHAPENUMBER,SHAPELIST,XSUPPORTCOORD,YSUPPORTCOORD,ZSUPPORTCOORD,createBlock) 
SHAPENUMBER,SHAPELIST = V_TOP(2,1,4,1,1,1,SHAPENUMBER,SHAPELIST,XLOADCOORD,YLOADCOORD,ZLOADCOORD,createBlock) 
SHAPENUMBER,SHAPELIST = V_TOP(4,1,4,1,1,1,SHAPENUMBER,SHAPELIST,XLOADCOORD,YLOADCOORD,ZLOADCOORD,createBlock) 
SHAPENUMBER,SHAPELIST = V_TOP(6,1,4,1,1,1,SHAPENUMBER,SHAPELIST,XLOADCOORD,YLOADCOORD,ZLOADCOORD,createBlock) 
SHAPENUMBER,SHAPELIST = V_TOP(8,1,4,1,1,1,SHAPENUMBER,SHAPELIST,XLOADCOORD,YLOADCOORD,ZLOADCOORD,createBlock) 
SHAPENUMBER,SHAPELIST = V_TOP(2,1,5,2,1,1,SHAPENUMBER,SHAPELIST,XBEAMCOORD,YBEAMCOORD,ZBEAMCOORD,createBlock) 
SHAPENUMBER,SHAPELIST = V_TOP(5,1,5,2,1,1,SHAPENUMBER,SHAPELIST,XBEAMCOORD,YBEAMCOORD,ZBEAMCOORD,createBlock) 
fitAll()


#CABLE REINFORCEMENT
createCurve( "CABLE1", [[ 0, 50, 25 ],[ 590, 50, 90 ],[ 610, 50, 70 ],[ 950, 50, 340 ],[ 1250, 50, 60 ],[ 1549.38, 50, 340 ],[ 1850.54, 50, 60 ],[ 2144.09, 50, 340 ],[ 2454.66, 50, 60 ],[ 2750, 50, 340 ],[ 3052.63, 50, 60 ],[ 3400, 50, 330 ],[ 3500, 50, 220 ],[ 4000, 50, 375 ]] )
createCurve( "CABLE2", [[ 0, 50, 375 ],[ 590, 50, 310 ],[ 610, 50, 330 ],[ 950, 50, 60 ],[ 1250, 50, 340 ],[ 1550, 50, 60 ],[ 1850, 50, 340 ],[ 2144, 50, 60 ],[ 2455, 50, 340 ],[ 2750, 50, 60 ],[ 3053, 50, 340 ],[ 3400, 50, 70 ],[ 3500, 50, 180 ],[ 4000, 50, 25 ]] )
createCurve( "CABLE3", [[ 0, 100, 25 ],[ 590, 100, 90 ],[ 610, 100, 70 ],[ 950, 100, 340 ],[ 1250, 100, 60 ],[ 1549.38, 100, 340 ],[ 1850.54, 100, 60 ],[ 2144.09, 100, 340 ],[ 2454.66, 100, 60 ],[ 2750, 100, 340 ],[ 3052.63, 100, 60 ],[ 3400, 100, 330 ],[ 3500, 100, 220 ],[ 4000, 100, 375 ]] )
createCurve( "CABLE4", [[ 0, 100, 375 ],[ 590, 100, 310 ],[ 610, 100, 330 ],[ 950, 100, 60 ],[ 1250, 100, 340 ],[ 1550, 100, 60 ],[ 1850, 100, 340 ],[ 2144, 100, 60 ],[ 2455, 100, 340 ],[ 2750, 100, 60 ],[ 3053, 100, 340 ],[ 3400, 100, 70 ],[ 3500, 100, 180 ],[ 4000, 100, 25 ]] )


ASCABLE1 = ["CABLE1"]
ASCABLE2 = ["CABLE2"]
ASCABLE3 = ["CABLE3"]
ASCABLE4 = ["CABLE4"]



# LONGITUDINAL Ø12 REINFORCEMENT TOP 
P1 = [XCOORD[0]+COVER,COVER+12,ZCOORD[1]-COVER-11]
P2 = [XCOORD[1]-COVER,COVER+12,ZCOORD[1]-COVER-11]
createLine( 'TOPREINFORCEMENT1',  P1, P2 )
P1 = [XCOORD[0]+COVER,COVER+38,ZCOORD[1]-COVER-11]
P2 = [XCOORD[1]-COVER,COVER+38,ZCOORD[1]-COVER-11]
createLine( 'TOPREINFORCEMENT2',  P1, P2 )
P1 = [XCOORD[0]+COVER,COVER+50,ZCOORD[1]-COVER-11]
P2 = [XCOORD[1]-COVER,COVER+50,ZCOORD[1]-COVER-11]
createLine( 'TOPREINFORCEMENT3',  P1, P2 )
P1 = [XCOORD[0]+COVER,COVER+62,ZCOORD[1]-COVER-11]
P2 = [XCOORD[1]-COVER,COVER+62,ZCOORD[1]-COVER-11]
createLine( 'TOPREINFORCEMENT4',  P1, P2 )
P1 = [XCOORD[0]+COVER,COVER+88,ZCOORD[1]-COVER-11]
P2 = [XCOORD[1]-COVER,COVER+88,ZCOORD[1]-COVER-11]
createLine( 'TOPREINFORCEMENT5',  P1, P2 )


P1 = [XCOORD[0]+COVER,COVER+12,ZCOORD[1]-COVER-39]
P2 = [XCOORD[1]-COVER,COVER+12,ZCOORD[1]-COVER-39]
createLine( 'TOPREINFORCEMENT6',  P1, P2 )
P1 = [XCOORD[0]+COVER,COVER+38,ZCOORD[1]-COVER-39]
P2 = [XCOORD[1]-COVER,COVER+38,ZCOORD[1]-COVER-39]
createLine( 'TOPREINFORCEMENT7',  P1, P2 )
P1 = [XCOORD[0]+COVER,COVER+50,ZCOORD[1]-COVER-39]
P2 = [XCOORD[1]-COVER,COVER+50,ZCOORD[1]-COVER-39]
createLine( 'TOPREINFORCEMENT8',  P1, P2 )
P1 = [XCOORD[0]+COVER,COVER+62,ZCOORD[1]-COVER-39]
P2 = [XCOORD[1]-COVER,COVER+62,ZCOORD[1]-COVER-39]
createLine( 'TOPREINFORCEMENT9',  P1, P2 )
P1 = [XCOORD[0]+COVER,COVER+88,ZCOORD[1]-COVER-39]
P2 = [XCOORD[1]-COVER,COVER+88,ZCOORD[1]-COVER-39]
createLine( 'TOPREINFORCEMENT10',  P1, P2 )





ASTOPREINFORCEMENT1 = ["TOPREINFORCEMENT1"]
ASTOPREINFORCEMENT2 = ["TOPREINFORCEMENT2"]
ASTOPREINFORCEMENT3 = ["TOPREINFORCEMENT3"]
ASTOPREINFORCEMENT4 = ["TOPREINFORCEMENT4"]
ASTOPREINFORCEMENT5 = ["TOPREINFORCEMENT5"]
ASTOPREINFORCEMENT6 = ["TOPREINFORCEMENT6"]
ASTOPREINFORCEMENT7 = ["TOPREINFORCEMENT7"]
ASTOPREINFORCEMENT8 = ["TOPREINFORCEMENT8"]
ASTOPREINFORCEMENT9 = ["TOPREINFORCEMENT9"]
ASTOPREINFORCEMENT10 = ["TOPREINFORCEMENT10"]






# LONGITUDINAL Ø12 REINFORCEMENT BOTTOM 
P1 = [XCOORD[0]+COVER,COVER+12,ZCOORD[0]+COVER+11]
P2 = [XCOORD[1]-COVER,COVER+12,ZCOORD[0]+COVER+11]
createLine( 'BOTTOMREINFORCEMENT1',  P1, P2 )
P1 = [XCOORD[0]+COVER,COVER+38,ZCOORD[0]+COVER+11]
P2 = [XCOORD[1]-COVER,COVER+38,ZCOORD[0]+COVER+11]
createLine( 'BOTTOMREINFORCEMENT2',  P1, P2 )
P1 = [XCOORD[0]+COVER,COVER+50,ZCOORD[0]+COVER+11]
P2 = [XCOORD[1]-COVER,COVER+50,ZCOORD[0]+COVER+11]
createLine( 'BOTTOMREINFORCEMENT3',  P1, P2 )
P1 = [XCOORD[0]+COVER,COVER+62,ZCOORD[0]+COVER+11]
P2 = [XCOORD[1]-COVER,COVER+62,ZCOORD[0]+COVER+11]
createLine( 'BOTTOMREINFORCEMENT4',  P1, P2 )
P1 = [XCOORD[0]+COVER,COVER+88,ZCOORD[0]+COVER+11]
P2 = [XCOORD[1]-COVER,COVER+88,ZCOORD[0]+COVER+11]
createLine( 'BOTTOMREINFORCEMENT5',  P1, P2 )
P1 = [XCOORD[0]+COVER,COVER+12,ZCOORD[0]+COVER+39]
P2 = [XCOORD[1]-COVER,COVER+12,ZCOORD[0]+COVER+39]
createLine( 'BOTTOMREINFORCEMENT6',  P1, P2 )
P1 = [XCOORD[0]+COVER,COVER+38,ZCOORD[0]+COVER+39]
P2 = [XCOORD[1]-COVER,COVER+38,ZCOORD[0]+COVER+39]
createLine( 'BOTTOMREINFORCEMENT7',  P1, P2 )
P1 = [XCOORD[0]+COVER,COVER+50,ZCOORD[0]+COVER+39]
P2 = [XCOORD[1]-COVER,COVER+50,ZCOORD[0]+COVER+39]
createLine( 'BOTTOMREINFORCEMENT8',  P1, P2 )
P1 = [XCOORD[0]+COVER,COVER+62,ZCOORD[0]+COVER+39]
P2 = [XCOORD[1]-COVER,COVER+62,ZCOORD[0]+COVER+39]
createLine( 'BOTTOMREINFORCEMENT9',  P1, P2 )
P1 = [XCOORD[0]+COVER,COVER+88,ZCOORD[0]+COVER+39]
P2 = [XCOORD[1]-COVER,COVER+88,ZCOORD[0]+COVER+39]
createLine( 'BOTTOMREINFORCEMENT10',  P1, P2 )




ASBOTTOMREINFORCEMENT1 = ["BOTTOMREINFORCEMENT1"]
ASBOTTOMREINFORCEMENT2 = ["BOTTOMREINFORCEMENT2"]
ASBOTTOMREINFORCEMENT3 = ["BOTTOMREINFORCEMENT3"]
ASBOTTOMREINFORCEMENT4 = ["BOTTOMREINFORCEMENT4"]
ASBOTTOMREINFORCEMENT5 = ["BOTTOMREINFORCEMENT5"]
ASBOTTOMREINFORCEMENT6 = ["BOTTOMREINFORCEMENT6"]
ASBOTTOMREINFORCEMENT7 = ["BOTTOMREINFORCEMENT7"]
ASBOTTOMREINFORCEMENT8 = ["BOTTOMREINFORCEMENT8"]
ASBOTTOMREINFORCEMENT9 = ["BOTTOMREINFORCEMENT9"]
ASBOTTOMREINFORCEMENT10 = ["BOTTOMREINFORCEMENT10"]



# SMALL STIRRUPS Ø4 TOP
XSTIRR = [COVER]
ASSTIRR = []
for i in range(1,100):
   XSTIRR.append(XSTIRR[i-1]+SPACING40)


SNUM = 1
for i in range(0,len(XSTIRR)):

   LINENAME = 'STIRRUP{}'.format(SNUM)
   createPolyline( LINENAME,[[ XSTIRR[i], 27, 327 ],[ XSTIRR[i], 123, 327 ],[ XSTIRR[i], 123, 373 ],[ XSTIRR[i], 27, 373 ]], True )
   ASSTIRR.append(LINENAME)
   SNUM = SNUM + 1


# SMALL STIRRUPS Ø4 BOTTOM
   
XSTIRR = [COVER]
ASSTIRRR = []
for i in range(1,100):
   XSTIRR.append(XSTIRR[i-1]+SPACING40)


SNUM = 1
for i in range(0,len(XSTIRR)):

   LINENAME = 'STIRRRUP{}'.format(SNUM)
   createPolyline( LINENAME, [[ XSTIRR[i], 27, 27 ],[ XSTIRR[i], 123, 27 ],[ XSTIRR[i], 123, 73 ],[ XSTIRR[i], 27, 73 ]], True )
   ASSTIRRR.append(LINENAME)
   SNUM = SNUM + 1


# LONG STIRRUPS Ø6 lEFT
XVERT1 = [COVER]
AS_VERT1 = []
for i in range(1,4):
   XVERT1.append(XVERT1[i-1]+SPACING40)

SNUM = 1
for i in range(0,len(XVERT1)):


		P1 = [XVERT1[i],46,ZCOORD[0]+COVER]
		P2 = [XVERT1[i],46,ZCOORD[1]-COVER]
		LINENAME = 'VERT1_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_VERT1.append(LINENAME)
		SNUM = SNUM + 1

		
# LONG STIRRUPS Ø6 lEFT		
X2VERT = [COVER]                         
AS_VERT2 = []
for i in range(1,4):
   X2VERT.append(X2VERT[i-1]+SPACING40)

SNUM = 1
for i in range(0,len(X2VERT)):


		P1 = [X2VERT[i],104,ZCOORD[0]+COVER]
		P2 = [X2VERT[i],104,ZCOORD[1]-COVER]
		LINENAME = 'VERT2_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_VERT2.append(LINENAME)
		SNUM = SNUM + 1		
		
		
# LONG STIRRUPS Ø12 lEFT		
X3VERT = [XSUPPORTCOORD[1]+SPACING45+SPACING40]     
AS_VERT3 = []                                
for i in range(1,3):
   X3VERT.append(X3VERT[i-1]+SPACING20)

SNUM = 1
for i in range(0,len(X3VERT)):


		P1 = [X3VERT[i],46,ZCOORD[0]+COVER]
		P2 = [X3VERT[i],46,ZCOORD[1]-COVER]
		LINENAME = 'VERT3_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_VERT3.append(LINENAME)
		SNUM = SNUM + 1		


# LONG STIRRUPS Ø12 lEFT		
X4VERT = [XSUPPORTCOORD[1]+SPACING45+SPACING40]
AS_VERT4 = []                                       
for i in range(1,3):
   X4VERT.append(X4VERT[i-1]+SPACING20)

SNUM = 1
for i in range(0,len(X3VERT)):


		P1 = [X4VERT[i],104,ZCOORD[0]+COVER]
		P2 = [X4VERT[i],104,ZCOORD[1]-COVER]
		LINENAME = 'VERT4_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_VERT4.append(LINENAME)
		SNUM = SNUM + 1		


# LONG STIRRUPS Ø12 RIGHT			
X5VERT = [XSUPPORTCOORD[3]-SPACING50+COVER]                                                    
AS_VERT5 = []
for i in range(1,3):
   X5VERT.append(X5VERT[i-1]+SPACING20)

SNUM = 1
for i in range(0,len(X5VERT)):


		P1 = [X5VERT[i],46,ZCOORD[0]+COVER]
		P2 = [X5VERT[i],46,ZCOORD[1]-COVER]
		LINENAME = 'VERT5_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_VERT5.append(LINENAME)
		SNUM = SNUM + 1			

		
		
# LONG STIRRUPS Ø12 RIGHT			
X6VERT = [XSUPPORTCOORD[3]-SPACING50+COVER]             
AS_VERT6 = []                                        
for i in range(1,3):
   X6VERT.append(X6VERT[i-1]+SPACING20)

SNUM = 1
for i in range(0,len(X6VERT)):


		P1 = [X6VERT[i],104,ZCOORD[0]+COVER]
		P2 = [X6VERT[i],104,ZCOORD[1]-COVER]
		LINENAME = 'VERT6_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_VERT6.append(LINENAME)
		SNUM = SNUM + 1				
		
		
		
# LONG STIRRUPS Ø6 RIGHT		 
X7VERT = [XSUPPORTCOORD[3]+SPACING50]                      
AS_VERT7 = []
for i in range(1,4):
   X7VERT.append(X7VERT[i-1]+SPACING40)

SNUM = 1
for i in range(0,len(X7VERT)):


		P1 = [X7VERT[i],46,ZCOORD[0]+COVER]
		P2 = [X7VERT[i],46,ZCOORD[1]-COVER]
		LINENAME = 'VERT7_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_VERT7.append(LINENAME)
		SNUM = SNUM + 1		

		
# LONG STIRRUPS Ø6 RIGHT		 
X8VERT = [XSUPPORTCOORD[3]+SPACING50]                     
AS_VERT8 = []
for i in range(1,4):
   X8VERT.append(X8VERT[i-1]+SPACING40)

SNUM = 1
for i in range(0,len(X8VERT)):


		P1 = [X8VERT[i],104,ZCOORD[0]+COVER]
		P2 = [X8VERT[i],104,ZCOORD[1]-COVER]
		LINENAME = 'VERT8_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_VERT8.append(LINENAME)
		SNUM = SNUM + 1				
		
		
		

# LONG STIRRUPS Ø10 BETWEEN OPENINGS	
		
X9VERT = [XSUPPORTCOORD[2]+286]                          
AS_VERT9 = []
for i in range(1,2):
   X9VERT.append(X9VERT[i-1]+SPACING30)

SNUM = 1
for i in range(0,len(X9VERT)):


		P1 = [X9VERT[i],48,ZCOORD[0]+COVER]
		P2 = [X9VERT[i],48,ZCOORD[1]-COVER]
		LINENAME = 'VERT9_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_VERT9.append(LINENAME)
		SNUM = SNUM + 1		

			
X10VERT = [XSUPPORTCOORD[2]+286]                          
AS_VERT10 = []
for i in range(1,2):
   X10VERT.append(X10VERT[i-1]+SPACING30)

SNUM = 1
for i in range(0,len(X10VERT)):


		P1 = [X10VERT[i],102,ZCOORD[0]+COVER]
		P2 = [X10VERT[i],102,ZCOORD[1]-COVER]
		LINENAME = 'VERT10_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_VERT10.append(LINENAME)
		SNUM = SNUM + 1			
		
		
X11VERT = [XSUPPORTCOORD[2]+586]
AS_VERT11 = []
for i in range(1,2):
   X11VERT.append(X11VERT[i-1]+SPACING30)

SNUM = 1
for i in range(0,len(X11VERT)):


		P1 = [X11VERT[i],48,ZCOORD[0]+COVER]
		P2 = [X11VERT[i],48,ZCOORD[1]-COVER]
		LINENAME = 'VERT11_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_VERT11.append(LINENAME)
		SNUM = SNUM + 1		

		
X12VERT = [XSUPPORTCOORD[2]+586]
AS_VERT12 = []
for i in range(1,2):
   X12VERT.append(X12VERT[i-1]+SPACING30)

SNUM = 1
for i in range(0,len(X12VERT)):


		P1 = [X12VERT[i],102,ZCOORD[0]+COVER]
		P2 = [X12VERT[i],102,ZCOORD[1]-COVER]
		LINENAME = 'VERT12_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_VERT12.append(LINENAME)
		SNUM = SNUM + 1		


		
X13VERT = [XSUPPORTCOORD[2]+886]
AS_VERT13 = []
for i in range(1,2):
   X13VERT.append(X13VERT[i-1]+SPACING30)

SNUM = 1
for i in range(0,len(X13VERT)):


		P1 = [X13VERT[i],48,ZCOORD[0]+COVER]
		P2 = [X13VERT[i],48,ZCOORD[1]-COVER]
		LINENAME = 'VERT13_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_VERT13.append(LINENAME)
		SNUM = SNUM + 1		

		
X14VERT = [XSUPPORTCOORD[2]+886]
AS_VERT14 = []
for i in range(1,2):
   X14VERT.append(X14VERT[i-1]+SPACING30)

SNUM = 1
for i in range(0,len(X14VERT)):


		P1 = [X14VERT[i],102,ZCOORD[0]+COVER]
		P2 = [X14VERT[i],102,ZCOORD[1]-COVER]
		LINENAME = 'VERT14_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_VERT14.append(LINENAME)
		SNUM = SNUM + 1				
		
		

X15VERT = [XSUPPORTCOORD[2]+1186]
AS_VERT15 = []
for i in range(1,2):
   X15VERT.append(X15VERT[i-1]+SPACING30)

SNUM = 1
for i in range(0,len(X15VERT)):


		P1 = [X15VERT[i],48,ZCOORD[0]+COVER]
		P2 = [X15VERT[i],48,ZCOORD[1]-COVER]
		LINENAME = 'VERT15_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_VERT15.append(LINENAME)
		SNUM = SNUM + 1		

		
X16VERT = [XSUPPORTCOORD[2]+1186]
AS_VERT16 = []
for i in range(1,2):
   X16VERT.append(X16VERT[i-1]+SPACING30)

SNUM = 1
for i in range(0,len(X16VERT)):


		P1 = [X16VERT[i],102,ZCOORD[0]+COVER]
		P2 = [X16VERT[i],102,ZCOORD[1]-COVER]
		LINENAME = 'VERT16_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_VERT16.append(LINENAME)
		SNUM = SNUM + 1			
		
		

X17VERT = [XSUPPORTCOORD[2]+1486]
AS_VERT17 = []
for i in range(1,2):
   X17VERT.append(X17VERT[i-1]+SPACING30)

SNUM = 1
for i in range(0,len(X17VERT)):


		P1 = [X17VERT[i],48,ZCOORD[0]+COVER]
		P2 = [X17VERT[i],48,ZCOORD[1]-COVER]
		LINENAME = 'VERT17_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_VERT17.append(LINENAME)
		SNUM = SNUM + 1				

		
		
X18VERT = [XSUPPORTCOORD[2]+1486]
AS_VERT18 = []
for i in range(1,2):
   X18VERT.append(X18VERT[i-1]+SPACING30)

SNUM = 1
for i in range(0,len(X18VERT)):


		P1 = [X18VERT[i],102,ZCOORD[0]+COVER]
		P2 = [X18VERT[i],102,ZCOORD[1]-COVER]
		LINENAME = 'VERT18_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_VERT18.append(LINENAME)
		SNUM = SNUM + 1		


		
X19VERT = [XSUPPORTCOORD[2]+1786]
AS_VERT19 = []
for i in range(1,2):
   X19VERT.append(X19VERT[i-1]+SPACING30)

SNUM = 1
for i in range(0,len(X19VERT)):


		P1 = [X19VERT[i],48,ZCOORD[0]+COVER]
		P2 = [X19VERT[i],48,ZCOORD[1]-COVER]
		LINENAME = 'VERT19_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_VERT19.append(LINENAME)
		SNUM = SNUM + 1	

		
X20VERT = [XSUPPORTCOORD[2]+1786]
AS_VERT20 = []
for i in range(1,2):
   X20VERT.append(X20VERT[i-1]+SPACING30)

SNUM = 1
for i in range(0,len(X20VERT)):


		P1 = [X20VERT[i],102,ZCOORD[0]+COVER]
		P2 = [X20VERT[i],102,ZCOORD[1]-COVER]
		LINENAME = 'VERT20_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_VERT20.append(LINENAME)
		SNUM = SNUM + 1			
		

		
X21VERT = [XSUPPORTCOORD[2]+2086]
AS_VERT21 = []
for i in range(1,2):
   X21VERT.append(X21VERT[i-1]+SPACING30)

SNUM = 1
for i in range(0,len(X21VERT)):


		P1 = [X21VERT[i],48,ZCOORD[0]+COVER]
		P2 = [X21VERT[i],48,ZCOORD[1]-COVER]
		LINENAME = 'VERT21_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_VERT21.append(LINENAME)
		SNUM = SNUM + 1	

		
X22VERT = [XSUPPORTCOORD[2]+2086]
AS_VERT22 = []
for i in range(1,2):
   X22VERT.append(X22VERT[i-1]+SPACING30)

SNUM = 1
for i in range(0,len(X22VERT)):


		P1 = [X22VERT[i],102,ZCOORD[0]+COVER]
		P2 = [X22VERT[i],102,ZCOORD[1]-COVER]
		LINENAME = 'VERT22_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_VERT22.append(LINENAME)
		SNUM = SNUM + 1			
		
		
		
X23VERT = [XSUPPORTCOORD[2]+2386]
AS_VERT23 = []
for i in range(1,2):
   X23VERT.append(X23VERT[i-1]+SPACING30)

SNUM = 1
for i in range(0,len(X23VERT)):


		P1 = [X23VERT[i],48,ZCOORD[0]+COVER]
		P2 = [X23VERT[i],48,ZCOORD[1]-COVER]
		LINENAME = 'VERT23_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_VERT23.append(LINENAME)
		SNUM = SNUM + 1	

		
X24VERT = [XSUPPORTCOORD[2]+2386]
AS_VERT24 = []
for i in range(1,2):
   X24VERT.append(X24VERT[i-1]+SPACING30)

SNUM = 1
for i in range(0,len(X24VERT)):


		P1 = [X24VERT[i],102,ZCOORD[0]+COVER]
		P2 = [X24VERT[i],102,ZCOORD[1]-COVER]
		LINENAME = 'VERT24_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_VERT24.append(LINENAME)
		SNUM = SNUM + 1			
		

		
X25VERT = [XSUPPORTCOORD[2]+2686]
AS_VERT25 = []
for i in range(1,2):
   X25VERT.append(X25VERT[i-1]+SPACING30)

SNUM = 1
for i in range(0,len(X25VERT)):


		P1 = [X25VERT[i],48,ZCOORD[0]+COVER]
		P2 = [X25VERT[i],48,ZCOORD[1]-COVER]
		LINENAME = 'VERT25_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_VERT25.append(LINENAME)
		SNUM = SNUM + 1	

		
X26VERT = [XSUPPORTCOORD[2]+2686]
AS_VERT26 = []
for i in range(1,2):
   X26VERT.append(X26VERT[i-1]+SPACING30)

SNUM = 1
for i in range(0,len(X26VERT)):


		P1 = [X26VERT[i],102,ZCOORD[0]+COVER]
		P2 = [X26VERT[i],102,ZCOORD[1]-COVER]
		LINENAME = 'VERT26_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_VERT26.append(LINENAME)
		SNUM = SNUM + 1			
		

		
X27VERT = [XSUPPORTCOORD[2]+2986]
AS_VERT27 = []
for i in range(1,2):
   X27VERT.append(X27VERT[i-1]+SPACING30)

SNUM = 1
for i in range(0,len(X27VERT)):


		P1 = [X27VERT[i],48,ZCOORD[0]+COVER]
		P2 = [X27VERT[i],48,ZCOORD[1]-COVER]
		LINENAME = 'VERT27_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_VERT27.append(LINENAME)
		SNUM = SNUM + 1	


X28VERT = [XSUPPORTCOORD[2]+2986]
AS_VERT28 = []
for i in range(1,2):
   X28VERT.append(X28VERT[i-1]+SPACING30)

SNUM = 1
for i in range(0,len(X28VERT)):


		P1 = [X28VERT[i],102,ZCOORD[0]+COVER]
		P2 = [X28VERT[i],102,ZCOORD[1]-COVER]
		LINENAME = 'VERT28_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_VERT28.append(LINENAME)
		SNUM = SNUM + 1	


		
X29VERT = [XSUPPORTCOORD[2]+3286]
AS_VERT29 = []
for i in range(1,2):
   X29VERT.append(X29VERT[i-1]+SPACING30)

SNUM = 1
for i in range(0,len(X29VERT)):


		P1 = [X29VERT[i],48,ZCOORD[0]+COVER]
		P2 = [X29VERT[i],48,ZCOORD[1]-COVER]
		LINENAME = 'VERT29_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_VERT29.append(LINENAME)
		SNUM = SNUM + 1	

X30VERT = [XSUPPORTCOORD[2]+3286]
AS_VERT30 = []
for i in range(1,2):
   X30VERT.append(X30VERT[i-1]+SPACING30)

SNUM = 1
for i in range(0,len(X30VERT)):


		P1 = [X30VERT[i],102,ZCOORD[0]+COVER]
		P2 = [X30VERT[i],102,ZCOORD[1]-COVER]
		LINENAME = 'VERT30_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_VERT30.append(LINENAME)
		SNUM = SNUM + 1	
		
		
# HORIZONTAL REINFORCEMENT/STIRRUPS IN WEB BETWEEN OPENINGS		


ZHOR1 = [ZCOORD[0]+SPACING100]       
AS_HOR1 = []
for k in range(1,6):
   ZHOR1.append(ZHOR1[k-1]+SPACING40)

SNUM = 1
for k in range(0,len(ZHOR1)):


		LINENAME = 'HOR1_WEB{}'.format(SNUM)
		createPolyline( LINENAME, [[ XSUPPORTCOORD[3]-23, 111, ZHOR1[k] ],[ XSUPPORTCOORD[3]-23, 40, ZHOR1[k] ],[ XSUPPORTCOORD[3]+23, 40, ZHOR1[k] ],[ XSUPPORTCOORD[3]+23, 111, ZHOR1[k] ]], True )
		AS_HOR1.append(LINENAME)
		SNUM = SNUM + 1




		
ZHOR2 = [ZCOORD[0]+SPACING100]       
AS_HOR2 = []
for k in range(1,6):
   ZHOR2.append(ZHOR2[k-1]+SPACING40)

SNUM = 1
for k in range(0,len(ZHOR2)):


		LINENAME = 'HOR2_WEB{}'.format(SNUM)
		createPolyline( LINENAME, [[ XSUPPORTCOORD[3]-323, 111, ZHOR2[k] ],[ XSUPPORTCOORD[3]-323, 40, ZHOR2[k] ],[ XSUPPORTCOORD[3]-277, 40, ZHOR2[k] ],[ XSUPPORTCOORD[3]-277, 111, ZHOR2[k] ]], True )
		AS_HOR2.append(LINENAME)
		SNUM = SNUM + 1

		
		

ZHOR3 = [ZCOORD[0]+SPACING100]   
AS_HOR3 = []
for k in range(1,6):
   ZHOR3.append(ZHOR3[k-1]+SPACING40)

SNUM = 1
for k in range(0,len(ZHOR3)):


		LINENAME = 'HOR3_WEB{}'.format(SNUM)
		createPolyline( LINENAME, [[ XSUPPORTCOORD[3]-623, 111, ZHOR3[k] ],[ XSUPPORTCOORD[3]-623, 40, ZHOR3[k] ],[ XSUPPORTCOORD[3]-577, 40, ZHOR3[k] ],[ XSUPPORTCOORD[3]-577, 111, ZHOR3[k] ]], True )
		AS_HOR3.append(LINENAME)
		SNUM = SNUM + 1



ZHOR4 = [ZCOORD[0]+SPACING100]
AS_HOR4 = []
for k in range(1,6):
   ZHOR4.append(ZHOR4[k-1]+SPACING40)

SNUM = 1
for k in range(0,len(ZHOR4)):


		LINENAME = 'HOR4_WEB{}'.format(SNUM)
		createPolyline( LINENAME, [[ XSUPPORTCOORD[3]-923, 111, ZHOR4[k] ],[ XSUPPORTCOORD[3]-923, 40, ZHOR4[k] ],[ XSUPPORTCOORD[3]-877, 40, ZHOR4[k] ],[ XSUPPORTCOORD[3]-877, 111, ZHOR4[k] ]], True )
		AS_HOR4.append(LINENAME)
		SNUM = SNUM + 1


ZHOR5 = [ZCOORD[0]+SPACING100]
AS_HOR5 = []
for k in range(1,6):
   ZHOR5.append(ZHOR5[k-1]+SPACING40)

SNUM = 1
for k in range(0,len(ZHOR5)):


		LINENAME = 'HOR5_WEB{}'.format(SNUM)
		createPolyline( LINENAME, [[ XSUPPORTCOORD[3]-1223, 111, ZHOR5[k] ],[ XSUPPORTCOORD[3]-1223, 40, ZHOR5[k] ],[ XSUPPORTCOORD[3]-1177, 40, ZHOR5[k] ],[ XSUPPORTCOORD[3]-1177, 111, ZHOR5[k] ]], True )
		AS_HOR5.append(LINENAME)
		SNUM = SNUM + 1


ZHOR6 = [ZCOORD[0]+SPACING100]
AS_HOR6 = []
for k in range(1,6):
   ZHOR6.append(ZHOR6[k-1]+SPACING40)

SNUM = 1
for k in range(0,len(ZHOR6)):


		LINENAME = 'HOR6_WEB{}'.format(SNUM)
		createPolyline( LINENAME, [[ XSUPPORTCOORD[3]-1523, 111, ZHOR6[k] ],[ XSUPPORTCOORD[3]-1523, 40, ZHOR6[k] ],[ XSUPPORTCOORD[3]-1477, 40, ZHOR6[k] ],[ XSUPPORTCOORD[3]-1477, 111, ZHOR6[k] ]], True )
		AS_HOR6.append(LINENAME)
		SNUM = SNUM + 1


ZHOR7 = [ZCOORD[0]+SPACING100] 
AS_HOR7 = []
for k in range(1,6):
   ZHOR7.append(ZHOR7[k-1]+SPACING40)

SNUM = 1
for k in range(0,len(ZHOR7)):


		LINENAME = 'HOR7_WEB{}'.format(SNUM)
		createPolyline( LINENAME, [[ XSUPPORTCOORD[3]-1823, 111, ZHOR7[k] ],[ XSUPPORTCOORD[3]-1823, 40, ZHOR7[k] ],[ XSUPPORTCOORD[3]-1777, 40, ZHOR7[k] ],[ XSUPPORTCOORD[3]-1777, 111, ZHOR7[k] ]], True )
		AS_HOR7.append(LINENAME)
		SNUM = SNUM + 1


ZHOR8 = [ZCOORD[0]+SPACING100] 
AS_HOR8 = []
for k in range(1,6):
   ZHOR8.append(ZHOR8[k-1]+SPACING40)

SNUM = 1
for k in range(0,len(ZHOR8)):


		LINENAME = 'HOR8_WEB{}'.format(SNUM)
		createPolyline( LINENAME, [[ XSUPPORTCOORD[3]-2123, 111, ZHOR8[k] ],[ XSUPPORTCOORD[3]-2123, 40, ZHOR8[k] ],[ XSUPPORTCOORD[3]-2077, 40, ZHOR8[k] ],[ XSUPPORTCOORD[3]-2077, 111, ZHOR8[k] ]], True )
		AS_HOR8.append(LINENAME)
		SNUM = SNUM + 1


ZHOR9 = [ZCOORD[0]+SPACING100]
AS_HOR9 = []
for k in range(1,6):
   ZHOR9.append(ZHOR9[k-1]+SPACING40)

SNUM = 1
for k in range(0,len(ZHOR9)):


		LINENAME = 'HOR9_WEB{}'.format(SNUM)
		createPolyline( LINENAME, [[ XSUPPORTCOORD[3]-2423, 111, ZHOR9[k] ],[ XSUPPORTCOORD[3]-2423, 40, ZHOR9[k] ],[ XSUPPORTCOORD[3]-2377, 40, ZHOR9[k] ],[ XSUPPORTCOORD[3]-2377, 111, ZHOR9[k] ]], True )
		AS_HOR9.append(LINENAME)
		SNUM = SNUM + 1


ZHOR10 = [ZCOORD[0]+SPACING100] 
AS_HOR10 = []
for k in range(1,6):
   ZHOR10.append(ZHOR10[k-1]+SPACING40)

SNUM = 1
for k in range(0,len(ZHOR10)):


		LINENAME = 'HOR10_WEB{}'.format(SNUM)
		createPolyline( LINENAME, [[ XSUPPORTCOORD[3]-2723, 111, ZHOR10[k] ],[ XSUPPORTCOORD[3]-2723, 40, ZHOR10[k] ],[ XSUPPORTCOORD[3]-2677, 40, ZHOR10[k] ],[ XSUPPORTCOORD[3]-2677, 111, ZHOR10[k] ]], True )
		AS_HOR10.append(LINENAME)
		SNUM = SNUM + 1


ZHOR11 = [ZCOORD[0]+SPACING100] 
AS_HOR11 = []
for k in range(1,6):
   ZHOR11.append(ZHOR11[k-1]+SPACING40)

SNUM = 1
for k in range(0,len(ZHOR11)):


		LINENAME = 'HOR11_WEB{}'.format(SNUM)
		createPolyline( LINENAME, [[ XSUPPORTCOORD[3]-3023, 111, ZHOR11[k] ],[ XSUPPORTCOORD[3]-3023, 40, ZHOR11[k] ],[ XSUPPORTCOORD[3]-2977, 40, ZHOR11[k] ],[ XSUPPORTCOORD[3]-2977, 111, ZHOR11[k] ]], True )
		AS_HOR11.append(LINENAME)
		SNUM = SNUM + 1


ZHOR12 = [ZCOORD[0]+SPACING100] 
AS_HOR12 = []
for k in range(1,6):
   ZHOR12.append(ZHOR12[k-1]+SPACING40)

SNUM = 1
for k in range(0,len(ZHOR12)):


		LINENAME = 'HOR12_WEB{}'.format(SNUM)
		createPolyline( LINENAME, [[ XSUPPORTCOORD[3]-3323, 111, ZHOR12[k] ],[ XSUPPORTCOORD[3]-3323, 40, ZHOR12[k] ],[ XSUPPORTCOORD[3]-3277, 40, ZHOR12[k] ],[ XSUPPORTCOORD[3]-3277, 111, ZHOR12[k] ]], True )
		AS_HOR12.append(LINENAME)
		SNUM = SNUM + 1


ZHOR13 = [ZCOORD[0]+SPACING100] 
AS_HOR13 = []
for k in range(1,6):
   ZHOR13.append(ZHOR13[k-1]+SPACING40)

SNUM = 1
for k in range(0,len(ZHOR13)):


		LINENAME = 'HOR13_WEB{}'.format(SNUM)
		createPolyline( LINENAME, [[ XSUPPORTCOORD[3]-3623, 111, ZHOR13[k] ],[ XSUPPORTCOORD[3]-3623, 40, ZHOR13[k] ],[ XSUPPORTCOORD[3]-3577, 40, ZHOR13[k] ],[ XSUPPORTCOORD[3]-3577, 111, ZHOR13[k] ]], True )
		AS_HOR13.append(LINENAME)
		SNUM = SNUM + 1


ZHOR14 = [ZCOORD[0]+SPACING100] 
AS_HOR14 = []
for k in range(1,6):
   ZHOR14.append(ZHOR14[k-1]+SPACING40)

SNUM = 1
for k in range(0,len(ZHOR14)):


		P1 = [XSUPPORTCOORD[0]+COVER,56,ZHOR14[k]]
		P2 = [XSUPPORTCOORD[2]+COVER,56,ZHOR14[k]]
		LINENAME = 'HOR14_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_HOR14.append(LINENAME)
		SNUM = SNUM + 1

		
ZHOR15 = [ZCOORD[0]+SPACING100] 
AS_HOR15 = []
for k in range(1,6):
   ZHOR15.append(ZHOR15[k-1]+SPACING40)

SNUM = 1
for k in range(0,len(ZHOR15)):


		P1 = [XSUPPORTCOORD[0]+COVER,96,ZHOR15[k]]
		P2 = [XSUPPORTCOORD[2]+COVER,96,ZHOR15[k]]
		LINENAME = 'HOR15_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_HOR15.append(LINENAME)
		SNUM = SNUM + 1
		
		
ZHOR16 = [ZCOORD[0]+SPACING100] 
AS_HOR16 = []
for k in range(1,6):
   ZHOR16.append(ZHOR16[k-1]+SPACING40)

SNUM = 1
for k in range(0,len(ZHOR16)):


		P1 = [XSUPPORTCOORD[3]-COVER,56,ZHOR16[k]]
		P2 = [XSUPPORTCOORD[5]-COVER,56,ZHOR16[k]]
		LINENAME = 'HOR16_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_HOR16.append(LINENAME)
		SNUM = SNUM + 1				
		
		
ZHOR17 = [ZCOORD[0]+SPACING100]
AS_HOR17 = []
for k in range(1,6):
   ZHOR17.append(ZHOR17[k-1]+SPACING40)

SNUM = 1
for k in range(0,len(ZHOR17)):


		P1 = [XSUPPORTCOORD[3]-COVER,96,ZHOR17[k]]
		P2 = [XSUPPORTCOORD[5]-COVER,96,ZHOR17[k]]
		LINENAME = 'HOR17_WEB{}'.format(SNUM)
		createLine( LINENAME,  P1, P2 )
		AS_HOR17.append(LINENAME)
		SNUM = SNUM + 1				
		
		

	
		




createCylinder( "Cylinder 1", [ 350, 0, 200 ], [ 0, 1, 0 ], 100, 150 )
subtract( "BLOCK1", [ "Cylinder 1" ], False, True )


createCylinder( "Cylinder 2", [ 650, 0, 200 ], [ 0, 1, 0 ], 100, 150 )
subtract( "BLOCK1", [ "Cylinder 2" ], False, True )


createCylinder( "Cylinder 3", [ 950, 0, 200 ], [ 0, 1, 0 ], 100, 150 )
subtract( "BLOCK1", [ "Cylinder 3" ], False, True )


createCylinder( "Cylinder 4", [ 1250, 0, 200 ], [ 0, 1, 0 ], 100, 150 )
subtract( "BLOCK1", [ "Cylinder 4" ], False, True )


createCylinder( "Cylinder 5", [ 1550, 0, 200 ], [ 0, 1, 0 ], 100, 150 )
subtract( "BLOCK1", [ "Cylinder 5" ], False, True )


createCylinder( "Cylinder 6", [ 1850, 0, 200 ], [ 0, 1, 0 ], 100, 150 )
subtract( "BLOCK1", [ "Cylinder 6" ], False, True )


createCylinder( "Cylinder 7", [ 2150, 0, 200 ], [ 0, 1, 0 ], 100, 150 )
subtract( "BLOCK1", [ "Cylinder 7" ], False, True )


createCylinder( "Cylinder 8", [ 2450, 0, 200 ], [ 0, 1, 0 ], 100, 150 )
subtract( "BLOCK1", [ "Cylinder 8" ], False, True )


createCylinder( "Cylinder 9", [ 2750, 0, 200 ], [ 0, 1, 0 ], 100, 150 )
subtract( "BLOCK1", [ "Cylinder 9" ], False, True )


createCylinder( "Cylinder 10", [ 3050, 0, 200 ], [ 0, 1, 0 ], 100, 150 )
subtract( "BLOCK1", [ "Cylinder 10" ], False, True )


createCylinder( "Cylinder 11", [ 3350, 0, 200 ], [ 0, 1, 0 ], 100, 150 )
subtract( "BLOCK1", [ "Cylinder 11" ], False, True )


createCylinder( "Cylinder 12", [ 3650, 0, 200 ], [ 0, 1, 0 ], 100, 150 )
subtract( "BLOCK1", [ "Cylinder 12" ], False, True )


# DEFINE PROPERTIES FOR THE CONCRETE GEOMETRY AND MATERIAL
# TOTAL STRAIN FIXED CRACKING
addMaterial( "Concrete", "CONCR", "TSCR", [] )
setParameter( MATERIAL, "Concrete", "LINEAR/ELASTI/YOUNG", YOUNGSMOD )
setParameter( MATERIAL, "Concrete", "LINEAR/ELASTI/POISON", POISSONRATIO )

setParameter( MATERIAL, "Concrete", "MODTYP/TOTCRK", "FIXED" )   

setParameter( MATERIAL, "Concrete", "COMPRS/COMCRV", "PARABO" )    
#setParameter( "MATERIAL", "Concrete", "COMPRS/COMCRV", "MC2010" )  
# setParameter( "MATERIAL", "Concrete", "COMPRS/COMCRV", "CONSTA" ) 
setParameter( MATERIAL, "Concrete", "COMPRS/COMSTR", FC )
setParameter( MATERIAL, "Concrete", "COMPRS/GC", GC )
setParameter( MATERIAL, "Concrete", "COMPRS/CONFIN/CNFCRV", "VECCHI" )
setParameter( MATERIAL, "Concrete", "COMPRS/REDUCT/REDCRV", "VC1993" )

setParameter( MATERIAL, "Concrete", "TENSIL/TENCRV", "EXPONE" )    
# setParameter( "MATERIAL", "Concrete", "TENSIL/TENCRV", "MC2010" ) 
# setParameter( "MATERIAL", "Concrete", "TENSIL/CBSPEC", "GOVIND" ) 
setParameter( "MATERIAL", "Concrete", "TENSIL/CBSPEC", "ROTS" )    
setParameter( MATERIAL, "Concrete", "TENSIL/TENSTR", FCT )
setParameter( MATERIAL, "Concrete", "TENSIL/GF1", GF ) 
setParameter( MATERIAL, "Concrete", "TENSIL/POISRE/POIRED", "DAMAGE" )  

# setParameter( MATERIAL, "Concrete", "SHEAR/SHRCRV", "CONSTA" )
setParameter( "MATERIAL", "Concrete", "SHEAR/SHRCRV", "DAMAGE" )  
setParameter( MATERIAL, "Concrete", "SHEAR/BETA", BETA )    

CONMATNAME = "Concrete"
addGeometry( CONMATNAME, "SOLID", "STRSOL", [] )
setParameter( GEOMET, CONMATNAME, "THICK", WIDTH )

assignMaterial( CONMATNAME, "SHAPE", SHAPELIST[0:1] )
assignGeometry( CONMATNAME, "SHAPE", SHAPELIST[0:1] )


# DEFINE PROPERTIES FOR THE REINFORCEMENT GEOMETRY AND MATERIAL
setReinforcementAspects( ASTOPREINFORCEMENT1 )
setReinforcementAspects( ASTOPREINFORCEMENT2 )
setReinforcementAspects( ASTOPREINFORCEMENT3 )
setReinforcementAspects( ASTOPREINFORCEMENT4 )
setReinforcementAspects( ASTOPREINFORCEMENT5 )
setReinforcementAspects( ASTOPREINFORCEMENT6 )
setReinforcementAspects( ASTOPREINFORCEMENT7 )
setReinforcementAspects( ASTOPREINFORCEMENT8 )
setReinforcementAspects( ASTOPREINFORCEMENT9 )
setReinforcementAspects( ASTOPREINFORCEMENT10 )
setReinforcementAspects( ASBOTTOMREINFORCEMENT1 )
setReinforcementAspects( ASBOTTOMREINFORCEMENT2 )
setReinforcementAspects( ASBOTTOMREINFORCEMENT3 )
setReinforcementAspects( ASBOTTOMREINFORCEMENT4 )
setReinforcementAspects( ASBOTTOMREINFORCEMENT5 )
setReinforcementAspects( ASBOTTOMREINFORCEMENT6 )
setReinforcementAspects( ASBOTTOMREINFORCEMENT7 )
setReinforcementAspects( ASBOTTOMREINFORCEMENT8 )
setReinforcementAspects( ASBOTTOMREINFORCEMENT9 )
setReinforcementAspects( ASBOTTOMREINFORCEMENT10 )
setReinforcementAspects( ASSTIRR )
setReinforcementAspects( ASSTIRRR )
setReinforcementAspects( AS_VERT1 )
setReinforcementAspects( AS_VERT2 )
setReinforcementAspects( AS_VERT3 )
setReinforcementAspects( AS_VERT4 )
setReinforcementAspects( AS_VERT5 )
setReinforcementAspects( AS_VERT6 )
setReinforcementAspects( AS_VERT7 )
setReinforcementAspects( AS_VERT8 )
setReinforcementAspects( AS_VERT9 )
setReinforcementAspects( AS_VERT10 )
setReinforcementAspects( AS_VERT11 )
setReinforcementAspects( AS_VERT12 )
setReinforcementAspects( AS_VERT13 )
setReinforcementAspects( AS_VERT14 )
setReinforcementAspects( AS_VERT15 )
setReinforcementAspects( AS_VERT16 )
setReinforcementAspects( AS_VERT17 )
setReinforcementAspects( AS_VERT18 )
setReinforcementAspects( AS_VERT19 )
setReinforcementAspects( AS_VERT20 )
setReinforcementAspects( AS_VERT21 )
setReinforcementAspects( AS_VERT22 )
setReinforcementAspects( AS_VERT23 )
setReinforcementAspects( AS_VERT24 )
setReinforcementAspects( AS_VERT25 )
setReinforcementAspects( AS_VERT26 )
setReinforcementAspects( AS_VERT27 )
setReinforcementAspects( AS_VERT28 )
setReinforcementAspects( AS_VERT29 )
setReinforcementAspects( AS_VERT30 )
setReinforcementAspects( AS_HOR1 )
setReinforcementAspects( AS_HOR2 )
setReinforcementAspects( AS_HOR3 )
setReinforcementAspects( AS_HOR4 )
setReinforcementAspects( AS_HOR5 )
setReinforcementAspects( AS_HOR6 )
setReinforcementAspects( AS_HOR7 )
setReinforcementAspects( AS_HOR8 )
setReinforcementAspects( AS_HOR9 )
setReinforcementAspects( AS_HOR10 )
setReinforcementAspects( AS_HOR11 )
setReinforcementAspects( AS_HOR12 )
setReinforcementAspects( AS_HOR13 )
setReinforcementAspects( AS_HOR14 )
setReinforcementAspects( AS_HOR15 )
setReinforcementAspects( AS_HOR16 )
setReinforcementAspects( AS_HOR17 )
setReinforcementAspects( ASCABLE1 )
setReinforcementAspects( ASCABLE2 )
setReinforcementAspects( ASCABLE3 )
setReinforcementAspects( ASCABLE4 )
RMATNAME = "Steel reinforcement" 
SMATNAME = "Stirrups"  
R06MATNAME = "Steel reinforcement2" 
R10MATNAME = "Steel reinforcement3" 
R12MATNAME = "Steel reinforcement4"  
RCABLEMATNAME = "Cable reinforcement"  


# DEFINE PROPERTIES FOR THE STEEL GEOMETRY AND MATERIAL
# TOTAL STRAIN FIXED CRACKING
addMaterial( "Steelplate", "MCSTEL", "TRESCA", [] )  
setParameter( MATERIAL, "Steelplate", "TREPLA/YIELD", "VMISES" )
setParameter( MATERIAL, "Steelplate", "LINEAR/ELASTI/YOUNG", ES_STEEL )
setParameter( MATERIAL, "Steelplate", "LINEAR/ELASTI/POISON", POISSON_STEEL ) 
setParameter( MATERIAL, "Steelplate", "TREPLA/YLDSTR", FY_Steel_Plate ) 

STEELMATNAME = "Steelplate"
addGeometry( STEELMATNAME, "SOLID", "STRSOL", [] )
setParameter( GEOMET, STEELMATNAME, "THICK", WIDTH )

assignMaterial( STEELMATNAME, "SHAPE", SHAPELIST[1:13] )
assignGeometry( STEELMATNAME, "SHAPE", SHAPELIST[1:13] )

addMaterial( "Steelbeam", "MCSTEL", "TRESCA", [] )  
setParameter( MATERIAL, "Steelbeam", "TREPLA/YIELD", "VMISES" )
setParameter( MATERIAL, "Steelbeam", "LINEAR/ELASTI/YOUNG", ES_STEELBEAM )
setParameter( MATERIAL, "Steelbeam", "LINEAR/ELASTI/POISON", POISSON_STEEL ) 
setParameter( MATERIAL, "Steelbeam", "TREPLA/YLDSTR", FY_Steel_Beam ) 

STEELMATNAME = "Steelbeam"
addGeometry( STEELMATNAME, "SOLID", "STRSOL", [] )
setParameter( GEOMET, STEELMATNAME, "THICK", WIDTH )

assignMaterial( STEELMATNAME, "SHAPE", SHAPELIST[13:17] )
assignGeometry( STEELMATNAME, "SHAPE", SHAPELIST[13:17] )


#SMAX AND EPSPLMAX ARE THE PARAMETERS FOR THE NONLINEAR HARDENING RELATION BETWEEN YIELD STRESS AND PLASTIC STRAIN   

SMAX04 = FY04 + EHTOT*(EPSMAX - FY04/ES_REINFORCEMENT)
EPSPLMAX04 = EPSMAX*(1-EHTOT/ES_REINFORCEMENT) + FY04/ES_REINFORCEMENT*(EHTOT/ES_REINFORCEMENT - 1)
SMAX06 = FY06 + EHTOT*(EPSMAX - FY06/ES_REINFORCEMENT)
EPSPLMAX06 = EPSMAX*(1-EHTOT/ES_REINFORCEMENT) + FY06/ES_REINFORCEMENT*(EHTOT/ES_REINFORCEMENT - 1)
SMAX10 = FY10 + EHTOT*(EPSMAX - FY10/ES_REINFORCEMENT)
EPSPLMAX10 = EPSMAX*(1-EHTOT/ES_REINFORCEMENT) + FY10/ES_REINFORCEMENT*(EHTOT/ES_REINFORCEMENT - 1)
SMAX12 = FY12 + EHTOT*(EPSMAX - FY12/ES_REINFORCEMENT)
EPSPLMAX12 = EPSMAX*(1-EHTOT/ES_REINFORCEMENT) + FY12/ES_REINFORCEMENT*(EHTOT/ES_REINFORCEMENT - 1)


addMaterial( RMATNAME, "REINFO", "VMISES", [] )
setParameter( MATERIAL, RMATNAME, "LINEAR/ELASTI/YOUNG", ES_REINFORCEMENT )
setParameter( MATERIAL, RMATNAME, "PLASTI/YLDTYP", "KAPSIG" )
setParameter( MATERIAL, RMATNAME, "PLASTI/HARDI2/KAPSIG", [] )
setParameter( MATERIAL, RMATNAME, "PLASTI/HARDI2/KAPSIG", [ 0, FY12, EPSPLMAX12, SMAX12 ] )

addMaterial( R06MATNAME, "REINFO", "VMISES", [] )
setParameter( MATERIAL, R06MATNAME, "LINEAR/ELASTI/YOUNG", ES_REINFORCEMENT )
setParameter( MATERIAL, R06MATNAME, "PLASTI/YLDTYP", "KAPSIG" )
setParameter( MATERIAL, R06MATNAME, "PLASTI/HARDI2/KAPSIG", [] )
setParameter( MATERIAL, R06MATNAME, "PLASTI/HARDI2/KAPSIG", [ 0, FY06, EPSPLMAX06, SMAX06 ] )

addMaterial( R10MATNAME, "REINFO", "VMISES", [] )
setParameter( MATERIAL, R10MATNAME, "LINEAR/ELASTI/YOUNG", ES_REINFORCEMENT )
setParameter( MATERIAL, R10MATNAME, "PLASTI/YLDTYP", "KAPSIG" )
setParameter( MATERIAL, R10MATNAME, "PLASTI/HARDI2/KAPSIG", [] )
setParameter( MATERIAL, R10MATNAME, "PLASTI/HARDI2/KAPSIG", [ 0, FY10, EPSPLMAX10, SMAX10 ] )

addMaterial( RCABLEMATNAME, "REINFO", "VMISES", [] )
setParameter( MATERIAL, RCABLEMATNAME, "LINEAR/ELASTI/YOUNG", ES_REINFORCEMENT )
setParameter( MATERIAL, RCABLEMATNAME, "PLASTI/YLDTYP", "KAPSIG" )
setParameter( MATERIAL, RCABLEMATNAME, "PLASTI/HARDI2/KAPSIG", [] )
setParameter( MATERIAL, RCABLEMATNAME, "PLASTI/HARDI2/KAPSIG", [ 0, FY10, EPSPLMAX10, SMAX10 ] )

addMaterial( R12MATNAME, "REINFO", "VMISES", [] )
setParameter( MATERIAL, R12MATNAME, "LINEAR/ELASTI/YOUNG", ES_REINFORCEMENT )
setParameter( MATERIAL, R12MATNAME, "PLASTI/YLDTYP", "KAPSIG" )
setParameter( MATERIAL, R12MATNAME, "PLASTI/HARDI2/KAPSIG", [] )
setParameter( MATERIAL, R12MATNAME, "PLASTI/HARDI2/KAPSIG", [ 0, FY12, EPSPLMAX12, SMAX12 ] )

addMaterial( SMATNAME, "REINFO", "VMISES", [] )
setParameter( MATERIAL, SMATNAME, "LINEAR/ELASTI/YOUNG", ES_REINFORCEMENT )
setParameter( MATERIAL, SMATNAME, "PLASTI/YLDTYP", "KAPSIG" )
setParameter( MATERIAL, SMATNAME, "PLASTI/HARDI2/KAPSIG", [] )
setParameter( MATERIAL, SMATNAME, "PLASTI/HARDI2/KAPSIG", [ 0, FY04, EPSPLMAX04, SMAX04 ] )



addGeometry( RMATNAME, "RELINE", "REBAR", [] )
setParameter( GEOMET, RMATNAME, "CROSSE", ASTOP1 )  
addGeometry( R12MATNAME, "RELINE", "REBAR", [] )
setParameter( GEOMET, R12MATNAME, "CROSSE", ASVERT3 )  
addGeometry( R06MATNAME, "RELINE", "REBAR", [] )
setParameter( GEOMET, R06MATNAME, "CROSSE", ASVERT1 )
addGeometry( R10MATNAME, "RELINE", "REBAR", [] )
setParameter( GEOMET, R10MATNAME, "CROSSE", ASVERT2 )
addGeometry( RCABLEMATNAME, "RELINE", "REBAR", [] )
setParameter( GEOMET, RCABLEMATNAME, "CROSSE", ASCABLE )
addGeometry( SMATNAME, "RELINE", "REBAR", [] )
setParameter( GEOMET, SMATNAME, "CROSSE", ASSTIRRUP )



assignMaterial( RMATNAME, "SHAPE", ASTOPREINFORCEMENT1 )
assignGeometry( RMATNAME, "SHAPE", ASTOPREINFORCEMENT1 )
assignMaterial( RMATNAME, "SHAPE", ASTOPREINFORCEMENT2 )
assignGeometry( RMATNAME, "SHAPE", ASTOPREINFORCEMENT2 )
assignMaterial( RMATNAME, "SHAPE", ASTOPREINFORCEMENT3 )
assignGeometry( RMATNAME, "SHAPE", ASTOPREINFORCEMENT3 )
assignMaterial( RMATNAME, "SHAPE", ASTOPREINFORCEMENT4 )
assignGeometry( RMATNAME, "SHAPE", ASTOPREINFORCEMENT4 )
assignMaterial( RMATNAME, "SHAPE", ASTOPREINFORCEMENT5 )
assignGeometry( RMATNAME, "SHAPE", ASTOPREINFORCEMENT5 )
assignMaterial( RMATNAME, "SHAPE", ASTOPREINFORCEMENT6 )
assignGeometry( RMATNAME, "SHAPE", ASTOPREINFORCEMENT6 )
assignMaterial( RMATNAME, "SHAPE", ASTOPREINFORCEMENT7 )
assignGeometry( RMATNAME, "SHAPE", ASTOPREINFORCEMENT7 )
assignMaterial( RMATNAME, "SHAPE", ASTOPREINFORCEMENT8 )
assignGeometry( RMATNAME, "SHAPE", ASTOPREINFORCEMENT8 )
assignMaterial( RMATNAME, "SHAPE", ASTOPREINFORCEMENT9 )
assignGeometry( RMATNAME, "SHAPE", ASTOPREINFORCEMENT9 )
assignMaterial( RMATNAME, "SHAPE", ASTOPREINFORCEMENT10 )
assignGeometry( RMATNAME, "SHAPE", ASTOPREINFORCEMENT10 )
assignMaterial( RMATNAME, "SHAPE", ASBOTTOMREINFORCEMENT1 )
assignGeometry( RMATNAME, "SHAPE", ASBOTTOMREINFORCEMENT1 )
assignMaterial( RMATNAME, "SHAPE", ASBOTTOMREINFORCEMENT2 )
assignGeometry( RMATNAME, "SHAPE", ASBOTTOMREINFORCEMENT2 )
assignMaterial( RMATNAME, "SHAPE", ASBOTTOMREINFORCEMENT3 )
assignGeometry( RMATNAME, "SHAPE", ASBOTTOMREINFORCEMENT3 )
assignMaterial( RMATNAME, "SHAPE", ASBOTTOMREINFORCEMENT4 )
assignGeometry( RMATNAME, "SHAPE", ASBOTTOMREINFORCEMENT4 )
assignMaterial( RMATNAME, "SHAPE", ASBOTTOMREINFORCEMENT5 )
assignGeometry( RMATNAME, "SHAPE", ASBOTTOMREINFORCEMENT5 )
assignMaterial( RMATNAME, "SHAPE", ASBOTTOMREINFORCEMENT6 )
assignGeometry( RMATNAME, "SHAPE", ASBOTTOMREINFORCEMENT6 )
assignMaterial( RMATNAME, "SHAPE", ASBOTTOMREINFORCEMENT7 )
assignGeometry( RMATNAME, "SHAPE", ASBOTTOMREINFORCEMENT7 )
assignMaterial( RMATNAME, "SHAPE", ASBOTTOMREINFORCEMENT8 )
assignGeometry( RMATNAME, "SHAPE", ASBOTTOMREINFORCEMENT8 )
assignMaterial( RMATNAME, "SHAPE", ASBOTTOMREINFORCEMENT9 )
assignGeometry( RMATNAME, "SHAPE", ASBOTTOMREINFORCEMENT9 )
assignMaterial( RMATNAME, "SHAPE", ASBOTTOMREINFORCEMENT10 )
assignGeometry( RMATNAME, "SHAPE", ASBOTTOMREINFORCEMENT10 )
assignMaterial( RCABLEMATNAME, "SHAPE", ASCABLE1 )
assignGeometry( RCABLEMATNAME, "SHAPE", ASCABLE1 )
assignMaterial( RCABLEMATNAME, "SHAPE", ASCABLE2 )
assignGeometry( RCABLEMATNAME, "SHAPE", ASCABLE2 )
assignMaterial( RCABLEMATNAME, "SHAPE", ASCABLE3 )
assignGeometry( RCABLEMATNAME, "SHAPE", ASCABLE3 )
assignMaterial( RCABLEMATNAME, "SHAPE", ASCABLE4 )
assignGeometry( RCABLEMATNAME, "SHAPE", ASCABLE4 )
assignMaterial( R12MATNAME, "SHAPE", AS_VERT3 )
assignGeometry( R12MATNAME, "SHAPE", AS_VERT3 )
assignMaterial( R12MATNAME, "SHAPE", AS_VERT4 )
assignGeometry( R12MATNAME, "SHAPE", AS_VERT4 )
assignMaterial( R12MATNAME, "SHAPE", AS_VERT5 )
assignGeometry( R12MATNAME, "SHAPE", AS_VERT5 )
assignMaterial( R12MATNAME, "SHAPE", AS_VERT6 )
assignGeometry( R12MATNAME, "SHAPE", AS_VERT6 )
assignMaterial( SMATNAME, "SHAPE", ASSTIRR )
assignGeometry( SMATNAME, "SHAPE", ASSTIRR )
assignMaterial( SMATNAME, "SHAPE", ASSTIRRR )
assignGeometry( SMATNAME, "SHAPE", ASSTIRRR )
assignMaterial( SMATNAME, "SHAPE", AS_HOR1 )
assignGeometry( SMATNAME, "SHAPE", AS_HOR1 )
assignMaterial( SMATNAME, "SHAPE", AS_HOR2 )
assignGeometry( SMATNAME, "SHAPE", AS_HOR2 )
assignMaterial( SMATNAME, "SHAPE", AS_HOR3 )
assignGeometry( SMATNAME, "SHAPE", AS_HOR3 )
assignMaterial( SMATNAME, "SHAPE", AS_HOR4 )
assignGeometry( SMATNAME, "SHAPE", AS_HOR4 )
assignMaterial( SMATNAME, "SHAPE", AS_HOR5 )
assignGeometry( SMATNAME, "SHAPE", AS_HOR5 )
assignMaterial( SMATNAME, "SHAPE", AS_HOR6 )
assignGeometry( SMATNAME, "SHAPE", AS_HOR6 )
assignMaterial( SMATNAME, "SHAPE", AS_HOR7 )
assignGeometry( SMATNAME, "SHAPE", AS_HOR7 )
assignMaterial( SMATNAME, "SHAPE", AS_HOR8 )
assignGeometry( SMATNAME, "SHAPE", AS_HOR8 )
assignMaterial( SMATNAME, "SHAPE", AS_HOR9 )
assignGeometry( SMATNAME, "SHAPE", AS_HOR9 )
assignMaterial( SMATNAME, "SHAPE", AS_HOR10 )
assignGeometry( SMATNAME, "SHAPE", AS_HOR10 )
assignMaterial( SMATNAME, "SHAPE", AS_HOR11 )
assignGeometry( SMATNAME, "SHAPE", AS_HOR11 )
assignMaterial( SMATNAME, "SHAPE", AS_HOR12 )
assignGeometry( SMATNAME, "SHAPE", AS_HOR12 )
assignMaterial( SMATNAME, "SHAPE", AS_HOR13 )
assignGeometry( SMATNAME, "SHAPE", AS_HOR13 )
assignMaterial( R06MATNAME, "SHAPE", AS_HOR14 )
assignGeometry( R06MATNAME, "SHAPE", AS_HOR14 )
assignMaterial( R06MATNAME, "SHAPE", AS_HOR15 )
assignGeometry( R06MATNAME, "SHAPE", AS_HOR15 )
assignMaterial( R06MATNAME, "SHAPE", AS_HOR16 )
assignGeometry( R06MATNAME, "SHAPE", AS_HOR16 )
assignMaterial( R06MATNAME, "SHAPE", AS_HOR17 )
assignGeometry( R06MATNAME, "SHAPE", AS_HOR17 )
assignMaterial( R06MATNAME, "SHAPE", AS_VERT1 )
assignGeometry( R06MATNAME, "SHAPE", AS_VERT1 )
assignMaterial( R06MATNAME, "SHAPE", AS_VERT2 )
assignGeometry( R06MATNAME, "SHAPE", AS_VERT2 )
assignMaterial( R06MATNAME, "SHAPE", AS_VERT7 )
assignGeometry( R06MATNAME, "SHAPE", AS_VERT7 )
assignMaterial( R06MATNAME, "SHAPE", AS_VERT8 )
assignGeometry( R06MATNAME, "SHAPE", AS_VERT8 )
assignMaterial( R10MATNAME, "SHAPE", AS_VERT9 )
assignGeometry( R10MATNAME, "SHAPE", AS_VERT9 )
assignMaterial( R10MATNAME, "SHAPE", AS_VERT10 )
assignGeometry( R10MATNAME, "SHAPE", AS_VERT10 )
assignMaterial( R10MATNAME, "SHAPE", AS_VERT11 )
assignGeometry( R10MATNAME, "SHAPE", AS_VERT11 )
assignMaterial( R10MATNAME, "SHAPE", AS_VERT12 )
assignGeometry( R10MATNAME, "SHAPE", AS_VERT12 )
assignMaterial( R10MATNAME, "SHAPE", AS_VERT13 )
assignGeometry( R10MATNAME, "SHAPE", AS_VERT13 )
assignMaterial( R10MATNAME, "SHAPE", AS_VERT14 )
assignGeometry( R10MATNAME, "SHAPE", AS_VERT14 )
assignMaterial( R10MATNAME, "SHAPE", AS_VERT15 )
assignGeometry( R10MATNAME, "SHAPE", AS_VERT15 )
assignMaterial( R10MATNAME, "SHAPE", AS_VERT16 )
assignGeometry( R10MATNAME, "SHAPE", AS_VERT16 )
assignMaterial( R10MATNAME, "SHAPE", AS_VERT17 )
assignGeometry( R10MATNAME, "SHAPE", AS_VERT17 )
assignMaterial( R10MATNAME, "SHAPE", AS_VERT18 )
assignGeometry( R10MATNAME, "SHAPE", AS_VERT18 )
assignMaterial( R10MATNAME, "SHAPE", AS_VERT19 )
assignGeometry( R10MATNAME, "SHAPE", AS_VERT19 )
assignMaterial( R10MATNAME, "SHAPE", AS_VERT20 )
assignGeometry( R10MATNAME, "SHAPE", AS_VERT20 )
assignMaterial( R10MATNAME, "SHAPE", AS_VERT21 )
assignGeometry( R10MATNAME, "SHAPE", AS_VERT21 )
assignMaterial( R10MATNAME, "SHAPE", AS_VERT22 )
assignGeometry( R10MATNAME, "SHAPE", AS_VERT22 )
assignMaterial( R10MATNAME, "SHAPE", AS_VERT23 )
assignGeometry( R10MATNAME, "SHAPE", AS_VERT23 )
assignMaterial( R10MATNAME, "SHAPE", AS_VERT24 )
assignGeometry( R10MATNAME, "SHAPE", AS_VERT24 )
assignMaterial( R10MATNAME, "SHAPE", AS_VERT25 )
assignGeometry( R10MATNAME, "SHAPE", AS_VERT25 )
assignMaterial( R10MATNAME, "SHAPE", AS_VERT26 )
assignGeometry( R10MATNAME, "SHAPE", AS_VERT26 )
assignMaterial( R10MATNAME, "SHAPE", AS_VERT27 )
assignGeometry( R10MATNAME, "SHAPE", AS_VERT27 )
assignMaterial( R10MATNAME, "SHAPE", AS_VERT28 )
assignGeometry( R10MATNAME, "SHAPE", AS_VERT28 )
assignMaterial( R10MATNAME, "SHAPE", AS_VERT29 )
assignGeometry( R10MATNAME, "SHAPE", AS_VERT29 )
assignMaterial( R10MATNAME, "SHAPE", AS_VERT30 )
assignGeometry( R10MATNAME, "SHAPE", AS_VERT30 )


# DEFINE SUPPORTS BC

createLineSupport( "LEFTSUPPORT", "Geometry support set 1" )
setParameter( "GEOMETRYSUPPORT", "LEFTSUPPORT", "AXES", [ 1, 2 ] )
setParameter( "GEOMETRYSUPPORT", "LEFTSUPPORT", "TRANSL", [ 1, 1, 1 ] )
setParameter( "GEOMETRYSUPPORT", "LEFTSUPPORT", "ROTATI", [ 0, 0, 0 ] )
attach( "GEOMETRYSUPPORT", "LEFTSUPPORT", "BLOCK2", [[ 100, 37.5, -45 ]] )
attach( "GEOMETRYSUPPORT", "LEFTSUPPORT", "BLOCK3", [[ 100, 112.5, -45 ]] )



createLineSupport( "RIGHTSUPPORT", "Geometry support set 1" )
setParameter( "GEOMETRYSUPPORT", "RIGHTSUPPORT", "AXES", [ 1, 2 ] )
setParameter( "GEOMETRYSUPPORT", "RIGHTSUPPORT", "TRANSL", [ 0, 1, 1 ] )
setParameter( "GEOMETRYSUPPORT", "RIGHTSUPPORT", "ROTATI", [ 0, 0, 0 ] )
attach( "GEOMETRYSUPPORT", "RIGHTSUPPORT", "BLOCK6", [[ 3900, 37.5, -45 ]] )
attach( "GEOMETRYSUPPORT", "RIGHTSUPPORT", "BLOCK7", [[ 3900, 112.5, -45 ]] )








createLineSupport( "LOADSUPPORT", "Geometry support set 1" )
setParameter( "GEOMETRYSUPPORT", "LOADSUPPORT", "AXES", [ 1, 2 ] )
setParameter( "GEOMETRYSUPPORT", "LOADSUPPORT", "TRANSL", [ 0, 0, 1 ] )
setParameter( "GEOMETRYSUPPORT", "LOADSUPPORT", "ROTATI", [ 0, 0, 0 ] )
attach( "GEOMETRYSUPPORT", "LOADSUPPORT", "BLOCK14", [[ 1250, 75, 540 ]] )
attach( "GEOMETRYSUPPORT", "LOADSUPPORT", "BLOCK16", [[ 2750, 75, 540 ]] )






# DEFINE LOAD
#2) DISPLACEMENT CONTROL (attach supports at loading plate)
addSet( GEOMETRYLOADSET, "Geometry load case 2" )
showView( "GEOM" )
createLineLoad( "Displacement control", "Geometry load case 2" )
setParameter( GEOMETRYLOAD, "Displacement control", "LODTYP", "DEFORM" )
setParameter( GEOMETRYLOAD, "Displacement control", "DEFORM/TR/VALUE", PRESCRIBEDDISPLACEMENT )
setParameter( GEOMETRYLOAD, "Displacement control", "DEFORM/TR/DIRECT", 3 )
attach( GEOMETRYLOAD, "Displacement control", "BLOCK14", [[ 1250, 75, 540 ]] )
attach( GEOMETRYLOAD, "Displacement control", "BLOCK16", [[ 2750, 75, 540 ]] )



COORDLEFTSUPPORT = [ XSUPPORTCOORD[1] , YSUPPORTCOORD[1], ZSUPPORTCOORD[0]-PLATETHICKNESS]
COORDRIGHTSUPPORT = [ XSUPPORTCOORD[4] , YSUPPORTCOORD[1] , ZSUPPORTCOORD[0]-PLATETHICKNESS ]
COORDLOADSUPPORT1 = [ XBEAMCOORD[2] , YBEAMCOORD[0]+SPACING75 , ZBEAMCOORD[5] ]
COORDLOADSUPPORT2 = [ XBEAMCOORD[5] , YBEAMCOORD[0]+SPACING75 , ZBEAMCOORD[5] ]



# INTERFACE BETWEEN LOADING PLATE & BEAM
addMaterial( "Interface_SOFT", "INTERF", "ELASTI", [] )
setParameter( "MATERIAL", "Interface_SOFT", "LINEAR/ELAS6/DSNZ", INTERFACE_NORMALSTIFFNESS )
setParameter( "MATERIAL", "Interface_SOFT", "LINEAR/ELAS6/DSSX", INTERFACE_ZEROTANGENTIALSTIFFNESS )
setParameter( "MATERIAL", "Interface_SOFT", "LINEAR/ELAS6/DSSY", INTERFACE_ZEROTANGENTIALSTIFFNESS )
setParameter( "MATERIAL", "Interface_SOFT", "LINEAR/ELAS6/DSSX", INTERFACE_ZEROTANGENTIALSTIFFNESS )
createConnection( "Interface_SOFT", "INTER", "SHAPEFACE" )
setParameter( "GEOMETRYCONNECTION", "Interface_SOFT", "MODE", "AUTO" )
attachTo( "GEOMETRYCONNECTION", "Interface_SOFT", "SOURCE", "BLOCK10", [[ 792.6427, 86.03595, 400 ]] )
attachTo( "GEOMETRYCONNECTION", "Interface_SOFT", "SOURCE", "BLOCK11", [[ 1692.6427, 86.03595, 400 ]] )
attachTo( "GEOMETRYCONNECTION", "Interface_SOFT", "SOURCE", "BLOCK12", [[ 2292.6427, 86.03595, 400 ]] )
attachTo( "GEOMETRYCONNECTION", "Interface_SOFT", "SOURCE", "BLOCK13", [[ 3192.6427, 86.03595, 400 ]] )
setElementClassType( "GEOMETRYCONNECTION", "Interface_SOFT", "STPLIF" )
assignMaterial( "Interface_SOFT", "GEOMETRYCONNECTION", "Interface_SOFT" )
resetGeometry( "GEOMETRYCONNECTION", "Interface_SOFT" )
setParameter( "GEOMETRYCONNECTION", "Interface_SOFT", "FLIP", False )
resetElementData( "GEOMETRYCONNECTION", "Interface_SOFT" )



# MESHING
setElementSize( SHAPELIST, ELEMENTSIZE )
setElementClassType( SHAPELIST, "STRSOL" )

generateMesh(shapes())

addElementData( "Element data 1" )
setParameter( DATA, "Element data 1", "INTEGR", "HIGH" ) 
assignElementData( "Element data 1", ELEMENT, SHAPELIST )



# SET UP NON-LINEAR ANALYSIS
analysis = "Nonlinear analysis"
command  = "Structural nonlinear"
addAnalysis( analysis )
addAnalysisCommand( analysis, "NONLIN", command )

setAnalysisCommandDetail( analysis, command, "EXECUT(1)/ITERAT/METHOD/METNAM", "NEWTON" ) 
setAnalysisCommandDetail( analysis, command, "EXECUT(1)/ITERAT/METHOD/NEWTON/TYPNAM", "REGULA" )  
setAnalysisCommandDetail( analysis, command, "EXECUT(1)/ITERAT/MAXITE", 40 )            
setAnalysisCommandDetail( analysis, command, "EXECUT(1)/ITERAT/CONVER/FORCE", True )
setAnalysisCommandDetail( analysis, command, "EXECUT(1)/ITERAT/CONVER/ENERGY", True )
setAnalysisCommandDetail( analysis, command, "EXECUT(1)/ITERAT/CONVER/DISPLA", False )
setAnalysisCommandDetail( analysis, command, "EXECUT(1)/ITERAT/CONVER/FORCE/TOLCON", 0.01 )  
setAnalysisCommandDetail( analysis, command, "EXECUT(1)/ITERAT/CONVER/FORCE/NOCONV", "CONTIN" )
setAnalysisCommandDetail( analysis, command, "EXECUT(1)/ITERAT/CONVER/ENERGY/TOLCON", 0.001 )  
setAnalysisCommandDetail( analysis, command, "EXECUT(1)/ITERAT/CONVER/ENERGY/NOCONV", "CONTIN" )  
setAnalysisCommandDetail( analysis, command, "EXECUT(1)/ITERAT/CONVER/SIMULT", False )
#addAnalysisCommandDetail( analysis, command, "EXECUT(1)/SOLVE/CHOLES" ) 
addAnalysisCommandDetail( "Nonlinear analysis", "Structural nonlinear", "EXECUT(1)/ITERAT/LINESE" )   
setAnalysisCommandDetail( "Nonlinear analysis", "Structural nonlinear", "EXECUT(1)/ITERAT/LINESE", True )     
setAnalysisCommandDetail( "Nonlinear analysis", "Structural nonlinear", "EXECUT(1)/ITERAT/LINESE/MAXLS", 10 )     
# addAnalysisCommandDetail( "Nonlinear analysis", "Structural nonlinear", "EXECUT(1)/LOAD/STEPS/EXPLIC/ARCLEN" )      
# setAnalysisCommandDetail( "Nonlinear analysis", "Structural nonlinear", "EXECUT(1)/LOAD/STEPS/EXPLIC/ARCLEN", True ) 












setAnalysisCommandDetail( analysis, command, "EXECUT(1)/LOAD/STEPS/EXPLIC/SIZES", "0.01(100)" )
setAnalysisCommandDetail( analysis, command, "EXECUT(1)/LOGGIN/REPORT/AMOUNT", "FULL" )
setAnalysisCommandDetail( analysis, command, "EXECUT(1)/LOGGIN/REPORT/TERMIN", "STEP" )
setAnalysisCommandDetail( analysis, command, "OUTPUT(1)/SELTYP", "USER" )
addAnalysisCommandDetail( analysis, command, "OUTPUT(1)/USER" )
addAnalysisCommandDetail( analysis, command, "OUTPUT(1)/USER/DISPLA(1)/TOTAL/TRANSL/GLOBAL" )
addAnalysisCommandDetail( analysis, command, "OUTPUT(1)/USER/FORCE(1)/REACTI/TRANSL/GLOBAL" )
# addAnalysisCommandDetail( analysis, command, "OUTPUT(1)/USER/DISPLA" )
# addAnalysisCommandDetail( analysis, command, "OUTPUT(1)/USER/FORCE" )
addAnalysisCommandDetail( analysis, command, "OUTPUT(1)/USER/STRAIN(1)" )
setAnalysisCommandDetail( analysis, command, "OUTPUT(1)/USER/STRAIN(1)/TOTAL/GREEN/GLOBAL/LOCATI", "INTPNT" )   
addAnalysisCommandDetail( analysis, command, "OUTPUT(1)/USER/STRAIN(2)/TOTAL/GREEN/PRINCI" )
setAnalysisCommandDetail( analysis, command, "OUTPUT(1)/USER/STRAIN(2)/TOTAL/GREEN/PRINCI/LOCATI", "INTPNT" )
addAnalysisCommandDetail( analysis, command, "OUTPUT(1)/USER/STRAIN(3)/CRACK/GREEN" )
addAnalysisCommandDetail( analysis, command, "OUTPUT(1)/USER/STRESS" )
setAnalysisCommandDetail( analysis, command, "OUTPUT(1)/USER/STRESS(1)/TOTAL/CAUCHY/GLOBAL/LOCATI", "INTPNT" )
addAnalysisCommandDetail( analysis, command, "OUTPUT(1)/USER/STRESS(2)/TOTAL/CAUCHY/PRINCI" )
setAnalysisCommandDetail( analysis, command, "OUTPUT(1)/USER/STRESS(2)/TOTAL/CAUCHY/PRINCI/LOCATI", "INTPNT" )
addAnalysisCommandDetail( "Nonlinear analysis", "Structural nonlinear", "OUTPUT(1)/USER/STRAIN(4)/CRKWDT/GREEN/GLOBAL" )      
setAnalysisCommandDetail( "Nonlinear analysis", "Structural nonlinear", "OUTPUT(1)/USER/STRAIN(4)/CRKWDT/GREEN/GLOBAL/LOCATI", "INTPNT" )
addAnalysisCommandDetail( "Nonlinear analysis", "Structural nonlinear", "OUTPUT(1)/USER/STRAIN(5)/CRKSUM/GREEN/GLOBAL" )          
setAnalysisCommandDetail( "Nonlinear analysis", "Structural nonlinear", "OUTPUT(1)/USER/STRAIN(5)/CRKSUM/GREEN/GLOBAL/LOCATI", "INTPNT" )
addAnalysisCommandDetail( "Nonlinear analysis", "Structural nonlinear", "OUTPUT(1)/USER/DISPLA(2)/INCREM/TRANSL/GLOBAL" )  




# EXPORT .DAT- AND .DCF-FILE
exportModel( "CONCRETE_BEAM_RCxcb_3D_EXPONENTIAL.dat", 10 )
saveAnalysisCommands( analysis, "CONCRETE_BEAM_RCxcb_3D_EXPONENTIAL.dcf")



# RUN ANALYSIS
runSolver( analysis )
# showView( "RESULT" )
# setViewPoint( "FRONT" )
# setResultPlot( "contours", "Cauchy Total Stresses/mappedintegrationpoint", "S2" )
# setViewSettingValue( "result view setting", "CONTOU/COUNT/NUMLVL", 20 )



# #FIND LOAD DISPLACEMENT CURVE 
DISPCOORD = [(XCOORD[0]+SPACING2000),YSUPPORTCOORD[1], ZCOORD[0] ]  
DISPNODE = findNearestNodes([DISPCOORD])
highlight(NODE,DISPNODE)
DISPNODELIST = [DISPNODE[0]]

FORCENODE1 = findNearestNodes([COORDLEFTSUPPORT])
FORCENODE2 = findNearestNodes([COORDRIGHTSUPPORT])
FORCENODES = [FORCENODE1[0],FORCENODE2[0]]
highlight(NODE,FORCENODES)

DISPLACEMENTS = []
LASTCASE = len(resultCases(analysis,''))
for i in range(0,LASTCASE):
    DISPLACEMENTS.append(resultData([analysis,"Output",resultCases(analysis,"Output")[i],"Displacements","TDtZ"],DISPNODE)[0][1])

REACTIONS = []
FORCE = 0
for i in range(0,LASTCASE):
    for j in FORCENODES:
        FORCE = FORCE + resultData([analysis,"Output",resultCases(analysis,"Output")[i],"Reaction Forces","FBZ"],(j,))[0][1]
    REACTIONS.append(FORCE)
    FORCE = 0

f = open('LOADDISP_Model1_RCxcb_3D_EXPONENTIAL.TXT','w')
for i in range(0,len(REACTIONS)):
    f.write('{0:20.6f} {1:20.6f}\n'.format(DISPLACEMENTS[i],REACTIONS[i]))

f.close()


# FIND SUPPORT FORCE TOTAL LOAD CURVE
SUPPORTNODE = findNearestNodes([COORDLEFTSUPPORT])
FORCENODE1 = findNearestNodes([COORDLEFTSUPPORT])
FORCENODE2 = findNearestNodes([COORDRIGHTSUPPORT])
FORCENODES = [FORCENODE1[0],FORCENODE2[0]]
highlight(NODE,FORCENODES)

SUPPORTLOAD = []
LASTCASE = len(resultCases(analysis,''))
for i in range(0,LASTCASE):
    SUPPORTLOAD.append(resultData([analysis,"Output",resultCases(analysis,"Output")[i],"Reaction Forces","FBZ"],SUPPORTNODE)[0][1])

REACTIONS = []
FORCE = 0
for i in range(0,LASTCASE):
    for j in FORCENODES:
        FORCE = FORCE + resultData([analysis,"Output",resultCases(analysis,"Output")[i],"Reaction Forces","FBZ"],(j,))[0][1]
    REACTIONS.append(FORCE)
    FORCE = 0

f = open('SUPPLOAD_Model1_RCxcb_3D_EXPONENTIAL.TXT','w')
for i in range(0,len(REACTIONS)):
    f.write('{0:20.6f} {1:20.6f}\n'.format(SUPPORTLOAD[i],REACTIONS[i]))

f.close()

